/* memory-monitor.c generated by valac 0.45.3, the Vala compiler
 * generated from memory-monitor.vala, do not modify */

/* memory-monitor.vala
 *
 * Copyright (C) 2017 Red Hat, Inc.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors: Petr Štětka <pstetka@redhat.com>
 */

#include <glib-object.h>
#include <glib.h>
#include <glibtop/mem.h>
#include <glibtop.h>
#include <glibtop/swap.h>
#include <glibtop/procmem.h>
#include <gobject/gvaluecollector.h>

#define TYPE_MONITOR (monitor_get_type ())
#define MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MONITOR, Monitor))
#define IS_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MONITOR))
#define MONITOR_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_MONITOR, MonitorIface))

typedef struct _Monitor Monitor;
typedef struct _MonitorIface MonitorIface;

#define USAGE_TYPE_PROCESS (usage_process_get_type ())
#define USAGE_PROCESS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), USAGE_TYPE_PROCESS, UsageProcess))
#define USAGE_PROCESS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), USAGE_TYPE_PROCESS, UsageProcessClass))
#define USAGE_IS_PROCESS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), USAGE_TYPE_PROCESS))
#define USAGE_IS_PROCESS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), USAGE_TYPE_PROCESS))
#define USAGE_PROCESS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), USAGE_TYPE_PROCESS, UsageProcessClass))

typedef struct _UsageProcess UsageProcess;
typedef struct _UsageProcessClass UsageProcessClass;

#define USAGE_TYPE_MEMORY_MONITOR (usage_memory_monitor_get_type ())
#define USAGE_MEMORY_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), USAGE_TYPE_MEMORY_MONITOR, UsageMemoryMonitor))
#define USAGE_MEMORY_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), USAGE_TYPE_MEMORY_MONITOR, UsageMemoryMonitorClass))
#define USAGE_IS_MEMORY_MONITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), USAGE_TYPE_MEMORY_MONITOR))
#define USAGE_IS_MEMORY_MONITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), USAGE_TYPE_MEMORY_MONITOR))
#define USAGE_MEMORY_MONITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), USAGE_TYPE_MEMORY_MONITOR, UsageMemoryMonitorClass))

typedef struct _UsageMemoryMonitor UsageMemoryMonitor;
typedef struct _UsageMemoryMonitorClass UsageMemoryMonitorClass;
typedef struct _UsageMemoryMonitorPrivate UsageMemoryMonitorPrivate;
typedef struct _UsageParamSpecMemoryMonitor UsageParamSpecMemoryMonitor;

struct _MonitorIface {
	GTypeInterface parent_iface;
	void (*update) (Monitor* self);
	void (*update_process) (Monitor* self, UsageProcess* * process);
};

struct _UsageMemoryMonitor {
	GTypeInstance parent_instance;
	volatile int ref_count;
	UsageMemoryMonitorPrivate * priv;
};

struct _UsageMemoryMonitorClass {
	GTypeClass parent_class;
	void (*finalize) (UsageMemoryMonitor *self);
};

struct _UsageMemoryMonitorPrivate {
	guint64 ram_usage;
	guint64 ram_total;
	guint64 swap_usage;
	guint64 swap_total;
};

struct _UsageParamSpecMemoryMonitor {
	GParamSpec parent_instance;
};

static gint UsageMemoryMonitor_private_offset;
static gpointer usage_memory_monitor_parent_class = NULL;
static MonitorIface * usage_memory_monitor_monitor_parent_iface = NULL;

GType usage_process_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (UsageProcess, g_object_unref)
GType monitor_get_type (void) G_GNUC_CONST;
gpointer usage_memory_monitor_ref (gpointer instance);
void usage_memory_monitor_unref (gpointer instance);
GParamSpec* usage_param_spec_memory_monitor (const gchar* name,
                                             const gchar* nick,
                                             const gchar* blurb,
                                             GType object_type,
                                             GParamFlags flags);
void usage_value_set_memory_monitor (GValue* value,
                                     gpointer v_object);
void usage_value_take_memory_monitor (GValue* value,
                                      gpointer v_object);
gpointer usage_value_get_memory_monitor (const GValue* value);
GType usage_memory_monitor_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (UsageMemoryMonitor, usage_memory_monitor_unref)
static void usage_memory_monitor_real_update (Monitor* base);
guint64 usage_memory_monitor_get_ram_usage (UsageMemoryMonitor* self);
guint64 usage_memory_monitor_get_swap_usage (UsageMemoryMonitor* self);
guint64 usage_memory_monitor_get_ram_total (UsageMemoryMonitor* self);
guint64 usage_memory_monitor_get_swap_total (UsageMemoryMonitor* self);
static void usage_memory_monitor_real_update_process (Monitor* base,
                                               UsageProcess* * process);
GPid usage_process_get_pid (UsageProcess* self);
void usage_process_set_mem_usage (UsageProcess* self,
                                  guint64 value);
UsageMemoryMonitor* usage_memory_monitor_new (void);
UsageMemoryMonitor* usage_memory_monitor_construct (GType object_type);
static void usage_memory_monitor_finalize (UsageMemoryMonitor * obj);

static inline gpointer
usage_memory_monitor_get_instance_private (UsageMemoryMonitor* self)
{
	return G_STRUCT_MEMBER_P (self, UsageMemoryMonitor_private_offset);
}

static void
usage_memory_monitor_real_update (Monitor* base)
{
	UsageMemoryMonitor * self;
	glibtop_mem mem = {0};
	glibtop_mem _tmp0_ = {0};
	glibtop_mem _tmp1_;
	glibtop_mem _tmp2_;
	glibtop_swap swap = {0};
	glibtop_swap _tmp3_ = {0};
	glibtop_swap _tmp4_;
	glibtop_swap _tmp5_;
#line 30 "../src/memory-monitor.vala"
	self = (UsageMemoryMonitor*) base;
#line 34 "../src/memory-monitor.vala"
	glibtop_get_mem (&_tmp0_);
#line 34 "../src/memory-monitor.vala"
	mem = _tmp0_;
#line 35 "../src/memory-monitor.vala"
	_tmp1_ = mem;
#line 35 "../src/memory-monitor.vala"
	self->priv->ram_usage = _tmp1_.user;
#line 36 "../src/memory-monitor.vala"
	_tmp2_ = mem;
#line 36 "../src/memory-monitor.vala"
	self->priv->ram_total = _tmp2_.total;
#line 40 "../src/memory-monitor.vala"
	glibtop_get_swap (&_tmp3_);
#line 40 "../src/memory-monitor.vala"
	swap = _tmp3_;
#line 41 "../src/memory-monitor.vala"
	_tmp4_ = swap;
#line 41 "../src/memory-monitor.vala"
	self->priv->swap_usage = _tmp4_.used;
#line 42 "../src/memory-monitor.vala"
	_tmp5_ = swap;
#line 42 "../src/memory-monitor.vala"
	self->priv->swap_total = _tmp5_.total;
#line 170 "memory-monitor.c"
}

guint64
usage_memory_monitor_get_ram_usage (UsageMemoryMonitor* self)
{
	guint64 result = 0ULL;
#line 45 "../src/memory-monitor.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 47 "../src/memory-monitor.vala"
	result = self->priv->ram_usage;
#line 47 "../src/memory-monitor.vala"
	return result;
#line 183 "memory-monitor.c"
}

guint64
usage_memory_monitor_get_swap_usage (UsageMemoryMonitor* self)
{
	guint64 result = 0ULL;
#line 49 "../src/memory-monitor.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 51 "../src/memory-monitor.vala"
	result = self->priv->swap_usage;
#line 51 "../src/memory-monitor.vala"
	return result;
#line 196 "memory-monitor.c"
}

guint64
usage_memory_monitor_get_ram_total (UsageMemoryMonitor* self)
{
	guint64 result = 0ULL;
#line 53 "../src/memory-monitor.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 55 "../src/memory-monitor.vala"
	result = self->priv->ram_total;
#line 55 "../src/memory-monitor.vala"
	return result;
#line 209 "memory-monitor.c"
}

guint64
usage_memory_monitor_get_swap_total (UsageMemoryMonitor* self)
{
	guint64 result = 0ULL;
#line 57 "../src/memory-monitor.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 59 "../src/memory-monitor.vala"
	result = self->priv->swap_total;
#line 59 "../src/memory-monitor.vala"
	return result;
#line 222 "memory-monitor.c"
}

static void
usage_memory_monitor_real_update_process (Monitor* base,
                                          UsageProcess* * process)
{
	UsageMemoryMonitor * self;
	glibtop_mem mem = {0};
	glibtop_proc_mem proc_mem = {0};
	glibtop_mem _tmp0_ = {0};
	GPid _tmp1_;
	GPid _tmp2_;
	glibtop_proc_mem _tmp3_ = {0};
	glibtop_proc_mem _tmp4_;
	glibtop_proc_mem _tmp5_;
#line 62 "../src/memory-monitor.vala"
	self = (UsageMemoryMonitor*) base;
#line 62 "../src/memory-monitor.vala"
	g_return_if_fail (*process != NULL);
#line 67 "../src/memory-monitor.vala"
	glibtop_get_mem (&_tmp0_);
#line 67 "../src/memory-monitor.vala"
	mem = _tmp0_;
#line 68 "../src/memory-monitor.vala"
	_tmp1_ = usage_process_get_pid (*process);
#line 68 "../src/memory-monitor.vala"
	_tmp2_ = _tmp1_;
#line 68 "../src/memory-monitor.vala"
	glibtop_get_proc_mem (&_tmp3_, _tmp2_);
#line 68 "../src/memory-monitor.vala"
	proc_mem = _tmp3_;
#line 70 "../src/memory-monitor.vala"
	_tmp4_ = proc_mem;
#line 70 "../src/memory-monitor.vala"
	_tmp5_ = proc_mem;
#line 70 "../src/memory-monitor.vala"
	usage_process_set_mem_usage (*process, _tmp4_.resident - _tmp5_.share);
#line 260 "memory-monitor.c"
}

UsageMemoryMonitor*
usage_memory_monitor_construct (GType object_type)
{
	UsageMemoryMonitor* self = NULL;
#line 23 "../src/memory-monitor.vala"
	self = (UsageMemoryMonitor*) g_type_create_instance (object_type);
#line 23 "../src/memory-monitor.vala"
	return self;
#line 271 "memory-monitor.c"
}

UsageMemoryMonitor*
usage_memory_monitor_new (void)
{
#line 23 "../src/memory-monitor.vala"
	return usage_memory_monitor_construct (USAGE_TYPE_MEMORY_MONITOR);
#line 279 "memory-monitor.c"
}

static void
usage_value_memory_monitor_init (GValue* value)
{
#line 23 "../src/memory-monitor.vala"
	value->data[0].v_pointer = NULL;
#line 287 "memory-monitor.c"
}

static void
usage_value_memory_monitor_free_value (GValue* value)
{
#line 23 "../src/memory-monitor.vala"
	if (value->data[0].v_pointer) {
#line 23 "../src/memory-monitor.vala"
		usage_memory_monitor_unref (value->data[0].v_pointer);
#line 297 "memory-monitor.c"
	}
}

static void
usage_value_memory_monitor_copy_value (const GValue* src_value,
                                       GValue* dest_value)
{
#line 23 "../src/memory-monitor.vala"
	if (src_value->data[0].v_pointer) {
#line 23 "../src/memory-monitor.vala"
		dest_value->data[0].v_pointer = usage_memory_monitor_ref (src_value->data[0].v_pointer);
#line 309 "memory-monitor.c"
	} else {
#line 23 "../src/memory-monitor.vala"
		dest_value->data[0].v_pointer = NULL;
#line 313 "memory-monitor.c"
	}
}

static gpointer
usage_value_memory_monitor_peek_pointer (const GValue* value)
{
#line 23 "../src/memory-monitor.vala"
	return value->data[0].v_pointer;
#line 322 "memory-monitor.c"
}

static gchar*
usage_value_memory_monitor_collect_value (GValue* value,
                                          guint n_collect_values,
                                          GTypeCValue* collect_values,
                                          guint collect_flags)
{
#line 23 "../src/memory-monitor.vala"
	if (collect_values[0].v_pointer) {
#line 333 "memory-monitor.c"
		UsageMemoryMonitor * object;
		object = collect_values[0].v_pointer;
#line 23 "../src/memory-monitor.vala"
		if (object->parent_instance.g_class == NULL) {
#line 23 "../src/memory-monitor.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 340 "memory-monitor.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 23 "../src/memory-monitor.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 344 "memory-monitor.c"
		}
#line 23 "../src/memory-monitor.vala"
		value->data[0].v_pointer = usage_memory_monitor_ref (object);
#line 348 "memory-monitor.c"
	} else {
#line 23 "../src/memory-monitor.vala"
		value->data[0].v_pointer = NULL;
#line 352 "memory-monitor.c"
	}
#line 23 "../src/memory-monitor.vala"
	return NULL;
#line 356 "memory-monitor.c"
}

static gchar*
usage_value_memory_monitor_lcopy_value (const GValue* value,
                                        guint n_collect_values,
                                        GTypeCValue* collect_values,
                                        guint collect_flags)
{
	UsageMemoryMonitor ** object_p;
	object_p = collect_values[0].v_pointer;
#line 23 "../src/memory-monitor.vala"
	if (!object_p) {
#line 23 "../src/memory-monitor.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 371 "memory-monitor.c"
	}
#line 23 "../src/memory-monitor.vala"
	if (!value->data[0].v_pointer) {
#line 23 "../src/memory-monitor.vala"
		*object_p = NULL;
#line 377 "memory-monitor.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 23 "../src/memory-monitor.vala"
		*object_p = value->data[0].v_pointer;
#line 381 "memory-monitor.c"
	} else {
#line 23 "../src/memory-monitor.vala"
		*object_p = usage_memory_monitor_ref (value->data[0].v_pointer);
#line 385 "memory-monitor.c"
	}
#line 23 "../src/memory-monitor.vala"
	return NULL;
#line 389 "memory-monitor.c"
}

GParamSpec*
usage_param_spec_memory_monitor (const gchar* name,
                                 const gchar* nick,
                                 const gchar* blurb,
                                 GType object_type,
                                 GParamFlags flags)
{
	UsageParamSpecMemoryMonitor* spec;
#line 23 "../src/memory-monitor.vala"
	g_return_val_if_fail (g_type_is_a (object_type, USAGE_TYPE_MEMORY_MONITOR), NULL);
#line 23 "../src/memory-monitor.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 23 "../src/memory-monitor.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 23 "../src/memory-monitor.vala"
	return G_PARAM_SPEC (spec);
#line 408 "memory-monitor.c"
}

gpointer
usage_value_get_memory_monitor (const GValue* value)
{
#line 23 "../src/memory-monitor.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, USAGE_TYPE_MEMORY_MONITOR), NULL);
#line 23 "../src/memory-monitor.vala"
	return value->data[0].v_pointer;
#line 418 "memory-monitor.c"
}

void
usage_value_set_memory_monitor (GValue* value,
                                gpointer v_object)
{
	UsageMemoryMonitor * old;
#line 23 "../src/memory-monitor.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, USAGE_TYPE_MEMORY_MONITOR));
#line 23 "../src/memory-monitor.vala"
	old = value->data[0].v_pointer;
#line 23 "../src/memory-monitor.vala"
	if (v_object) {
#line 23 "../src/memory-monitor.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, USAGE_TYPE_MEMORY_MONITOR));
#line 23 "../src/memory-monitor.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 23 "../src/memory-monitor.vala"
		value->data[0].v_pointer = v_object;
#line 23 "../src/memory-monitor.vala"
		usage_memory_monitor_ref (value->data[0].v_pointer);
#line 440 "memory-monitor.c"
	} else {
#line 23 "../src/memory-monitor.vala"
		value->data[0].v_pointer = NULL;
#line 444 "memory-monitor.c"
	}
#line 23 "../src/memory-monitor.vala"
	if (old) {
#line 23 "../src/memory-monitor.vala"
		usage_memory_monitor_unref (old);
#line 450 "memory-monitor.c"
	}
}

void
usage_value_take_memory_monitor (GValue* value,
                                 gpointer v_object)
{
	UsageMemoryMonitor * old;
#line 23 "../src/memory-monitor.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, USAGE_TYPE_MEMORY_MONITOR));
#line 23 "../src/memory-monitor.vala"
	old = value->data[0].v_pointer;
#line 23 "../src/memory-monitor.vala"
	if (v_object) {
#line 23 "../src/memory-monitor.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, USAGE_TYPE_MEMORY_MONITOR));
#line 23 "../src/memory-monitor.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 23 "../src/memory-monitor.vala"
		value->data[0].v_pointer = v_object;
#line 471 "memory-monitor.c"
	} else {
#line 23 "../src/memory-monitor.vala"
		value->data[0].v_pointer = NULL;
#line 475 "memory-monitor.c"
	}
#line 23 "../src/memory-monitor.vala"
	if (old) {
#line 23 "../src/memory-monitor.vala"
		usage_memory_monitor_unref (old);
#line 481 "memory-monitor.c"
	}
}

static void
usage_memory_monitor_class_init (UsageMemoryMonitorClass * klass,
                                 gpointer klass_data)
{
#line 23 "../src/memory-monitor.vala"
	usage_memory_monitor_parent_class = g_type_class_peek_parent (klass);
#line 23 "../src/memory-monitor.vala"
	((UsageMemoryMonitorClass *) klass)->finalize = usage_memory_monitor_finalize;
#line 23 "../src/memory-monitor.vala"
	g_type_class_adjust_private_offset (klass, &UsageMemoryMonitor_private_offset);
#line 495 "memory-monitor.c"
}

static void
usage_memory_monitor_monitor_interface_init (MonitorIface * iface,
                                             gpointer iface_data)
{
#line 23 "../src/memory-monitor.vala"
	usage_memory_monitor_monitor_parent_iface = g_type_interface_peek_parent (iface);
#line 23 "../src/memory-monitor.vala"
	iface->update = (void (*) (Monitor*)) usage_memory_monitor_real_update;
#line 23 "../src/memory-monitor.vala"
	iface->update_process = (void (*) (Monitor*, UsageProcess* *)) usage_memory_monitor_real_update_process;
#line 508 "memory-monitor.c"
}

static void
usage_memory_monitor_instance_init (UsageMemoryMonitor * self,
                                    gpointer klass)
{
#line 23 "../src/memory-monitor.vala"
	self->priv = usage_memory_monitor_get_instance_private (self);
#line 23 "../src/memory-monitor.vala"
	self->ref_count = 1;
#line 519 "memory-monitor.c"
}

static void
usage_memory_monitor_finalize (UsageMemoryMonitor * obj)
{
	UsageMemoryMonitor * self;
#line 23 "../src/memory-monitor.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, USAGE_TYPE_MEMORY_MONITOR, UsageMemoryMonitor);
#line 23 "../src/memory-monitor.vala"
	g_signal_handlers_destroy (self);
#line 530 "memory-monitor.c"
}

GType
usage_memory_monitor_get_type (void)
{
	static volatile gsize usage_memory_monitor_type_id__volatile = 0;
	if (g_once_init_enter (&usage_memory_monitor_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { usage_value_memory_monitor_init, usage_value_memory_monitor_free_value, usage_value_memory_monitor_copy_value, usage_value_memory_monitor_peek_pointer, "p", usage_value_memory_monitor_collect_value, "p", usage_value_memory_monitor_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (UsageMemoryMonitorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) usage_memory_monitor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UsageMemoryMonitor), 0, (GInstanceInitFunc) usage_memory_monitor_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		static const GInterfaceInfo monitor_info = { (GInterfaceInitFunc) usage_memory_monitor_monitor_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType usage_memory_monitor_type_id;
		usage_memory_monitor_type_id = g_type_register_fundamental (g_type_fundamental_next (), "UsageMemoryMonitor", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_type_add_interface_static (usage_memory_monitor_type_id, TYPE_MONITOR, &monitor_info);
		UsageMemoryMonitor_private_offset = g_type_add_instance_private (usage_memory_monitor_type_id, sizeof (UsageMemoryMonitorPrivate));
		g_once_init_leave (&usage_memory_monitor_type_id__volatile, usage_memory_monitor_type_id);
	}
	return usage_memory_monitor_type_id__volatile;
}

gpointer
usage_memory_monitor_ref (gpointer instance)
{
	UsageMemoryMonitor * self;
	self = instance;
#line 23 "../src/memory-monitor.vala"
	g_atomic_int_inc (&self->ref_count);
#line 23 "../src/memory-monitor.vala"
	return instance;
#line 560 "memory-monitor.c"
}

void
usage_memory_monitor_unref (gpointer instance)
{
	UsageMemoryMonitor * self;
	self = instance;
#line 23 "../src/memory-monitor.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 23 "../src/memory-monitor.vala"
		USAGE_MEMORY_MONITOR_GET_CLASS (self)->finalize (self);
#line 23 "../src/memory-monitor.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 574 "memory-monitor.c"
	}
}

