/* process.c generated by valac 0.45.3, the Vala compiler
 * generated from process.vala, do not modify */

/* process.vala
 *
 * Copyright (C) 2017 Red Hat, Inc.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors: Petr Štětka <pstetka@redhat.com>
 */

#define _GNU_SOURCE

#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <glibtop/procstate.h>
#include <glibtop.h>
#include <glibtop/procuid.h>
#include <glibtop/procargs.h>
#include <fcntl.h>
#include <sys/types.h>
#include <unistd.h>

#define USAGE_TYPE_PROCESS (usage_process_get_type ())
#define USAGE_PROCESS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), USAGE_TYPE_PROCESS, UsageProcess))
#define USAGE_PROCESS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), USAGE_TYPE_PROCESS, UsageProcessClass))
#define USAGE_IS_PROCESS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), USAGE_TYPE_PROCESS))
#define USAGE_IS_PROCESS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), USAGE_TYPE_PROCESS))
#define USAGE_PROCESS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), USAGE_TYPE_PROCESS, UsageProcessClass))

typedef struct _UsageProcess UsageProcess;
typedef struct _UsageProcessClass UsageProcessClass;
typedef struct _UsageProcessPrivate UsageProcessPrivate;
typedef enum  {
	USAGE_PROCESS_STATUS_RUNNING,
	USAGE_PROCESS_STATUS_SLEEPING,
	USAGE_PROCESS_STATUS_DEAD
} UsageProcessStatus;

#define USAGE_TYPE_PROCESS_STATUS (usage_process_status_get_type ())
enum  {
	USAGE_PROCESS_0_PROPERTY,
	USAGE_PROCESS_PID_PROPERTY,
	USAGE_PROCESS_CMDLINE_PROPERTY,
	USAGE_PROCESS_UID_PROPERTY,
	USAGE_PROCESS_START_TIME_PROPERTY,
	USAGE_PROCESS_CPU_LOAD_PROPERTY,
	USAGE_PROCESS_X_CPU_LOAD_PROPERTY,
	USAGE_PROCESS_CPU_LAST_USED_PROPERTY,
	USAGE_PROCESS_X_CPU_LAST_USED_PROPERTY,
	USAGE_PROCESS_LAST_PROCESSOR_PROPERTY,
	USAGE_PROCESS_MEM_USAGE_PROPERTY,
	USAGE_PROCESS_GAMEMODE_PROPERTY,
	USAGE_PROCESS_MARK_AS_UPDATED_PROPERTY,
	USAGE_PROCESS_STATUS_PROPERTY,
	USAGE_PROCESS_APP_ID_PROPERTY,
	USAGE_PROCESS_NUM_PROPERTIES
};
static GParamSpec* usage_process_properties[USAGE_PROCESS_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_key_file_unref0(var) ((var == NULL) ? NULL : (var = (g_key_file_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_io_channel_unref0(var) ((var == NULL) ? NULL : (var = (g_io_channel_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))

struct _UsageProcess {
	GObject parent_instance;
	UsageProcessPrivate * priv;
};

struct _UsageProcessClass {
	GObjectClass parent_class;
};

struct _UsageProcessPrivate {
	GPid _pid;
	gchar* _cmdline;
	guint _uid;
	guint64 _start_time;
	gdouble _cpu_load;
	gdouble _x_cpu_load;
	guint64 _cpu_last_used;
	guint64 _x_cpu_last_used;
	guint _last_processor;
	guint64 _mem_usage;
	gboolean _gamemode;
	gboolean _mark_as_updated;
	UsageProcessStatus _status;
	gchar* _app_id;
	gboolean _app_id_checked;
};

static gint UsageProcess_private_offset;
static gpointer usage_process_parent_class = NULL;

GType usage_process_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (UsageProcess, g_object_unref)
GType usage_process_status_get_type (void) G_GNUC_CONST;
UsageProcess* usage_process_new (GPid pid);
UsageProcess* usage_process_construct (GType object_type,
                                       GPid pid);
static void usage_process_set_pid (UsageProcess* self,
                            GPid value);
gchar* usage_process_get_full_process_cmd (GPid pid);
static void usage_process_set_cmdline (UsageProcess* self,
                                const gchar* value);
static guint _usage_process_get_uid (UsageProcess* self);
static void usage_process_set_uid (UsageProcess* self,
                            guint value);
void usage_process_update_status (UsageProcess* self);
GPid usage_process_get_pid (UsageProcess* self);
static void usage_process_set_status (UsageProcess* self,
                               UsageProcessStatus value);
gdouble usage_process_get_cpu_load (UsageProcess* self);
void usage_process_set_mark_as_updated (UsageProcess* self,
                                        gboolean value);
gchar* usage_process_first_component (const gchar* str);
gchar* usage_process_sanitize_name (const gchar* name);
gchar* usage_process_read_app_id (GPid pid);
GKeyFile* usage_process_read_flatpak_info (GPid pid);
const gchar* usage_process_get_cmdline (UsageProcess* self);
guint usage_process_get_uid (UsageProcess* self);
guint64 usage_process_get_start_time (UsageProcess* self);
void usage_process_set_start_time (UsageProcess* self,
                                   guint64 value);
void usage_process_set_cpu_load (UsageProcess* self,
                                 gdouble value);
gdouble usage_process_get_x_cpu_load (UsageProcess* self);
void usage_process_set_x_cpu_load (UsageProcess* self,
                                   gdouble value);
guint64 usage_process_get_cpu_last_used (UsageProcess* self);
void usage_process_set_cpu_last_used (UsageProcess* self,
                                      guint64 value);
guint64 usage_process_get_x_cpu_last_used (UsageProcess* self);
void usage_process_set_x_cpu_last_used (UsageProcess* self,
                                        guint64 value);
guint usage_process_get_last_processor (UsageProcess* self);
void usage_process_set_last_processor (UsageProcess* self,
                                       guint value);
guint64 usage_process_get_mem_usage (UsageProcess* self);
void usage_process_set_mem_usage (UsageProcess* self,
                                  guint64 value);
gboolean usage_process_get_gamemode (UsageProcess* self);
void usage_process_set_gamemode (UsageProcess* self,
                                 gboolean value);
gboolean usage_process_get_mark_as_updated (UsageProcess* self);
UsageProcessStatus usage_process_get_status (UsageProcess* self);
const gchar* usage_process_get_app_id (UsageProcess* self);
static void usage_process_finalize (GObject * obj);
static void _vala_usage_process_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec);
static void _vala_usage_process_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

static inline gpointer
usage_process_get_instance_private (UsageProcess* self)
{
	return G_STRUCT_MEMBER_P (self, UsageProcess_private_offset);
}

UsageProcess*
usage_process_construct (GType object_type,
                         GPid pid)
{
	UsageProcess * self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 46 "../src/process.vala"
	self = (UsageProcess*) g_object_new (object_type, NULL);
#line 48 "../src/process.vala"
	usage_process_set_pid (self, pid);
#line 49 "../src/process.vala"
	_tmp0_ = usage_process_get_full_process_cmd (pid);
#line 49 "../src/process.vala"
	_tmp1_ = _tmp0_;
#line 49 "../src/process.vala"
	usage_process_set_cmdline (self, _tmp1_);
#line 49 "../src/process.vala"
	_g_free0 (_tmp1_);
#line 50 "../src/process.vala"
	usage_process_set_uid (self, _usage_process_get_uid (self));
#line 46 "../src/process.vala"
	return self;
#line 212 "process.c"
}

UsageProcess*
usage_process_new (GPid pid)
{
#line 46 "../src/process.vala"
	return usage_process_construct (USAGE_TYPE_PROCESS, pid);
#line 220 "process.c"
}

void
usage_process_update_status (UsageProcess* self)
{
	glibtop_proc_state proc_state = {0};
	GPid _tmp0_;
	glibtop_proc_state _tmp1_ = {0};
	glibtop_proc_state _tmp2_;
	gdouble _tmp3_;
#line 53 "../src/process.vala"
	g_return_if_fail (self != NULL);
#line 56 "../src/process.vala"
	_tmp0_ = self->priv->_pid;
#line 56 "../src/process.vala"
	glibtop_get_proc_state (&_tmp1_, _tmp0_);
#line 56 "../src/process.vala"
	proc_state = _tmp1_;
#line 58 "../src/process.vala"
	_tmp2_ = proc_state;
#line 58 "../src/process.vala"
	switch (_tmp2_.state) {
#line 58 "../src/process.vala"
		case GLIBTOP_PROCESS_RUNNING:
#line 58 "../src/process.vala"
		case GLIBTOP_PROCESS_UNINTERRUPTIBLE:
#line 247 "process.c"
		{
#line 62 "../src/process.vala"
			usage_process_set_status (self, USAGE_PROCESS_STATUS_RUNNING);
#line 63 "../src/process.vala"
			break;
#line 253 "process.c"
		}
#line 58 "../src/process.vala"
		case GLIBTOP_PROCESS_SWAPPING:
#line 58 "../src/process.vala"
		case GLIBTOP_PROCESS_INTERRUPTIBLE:
#line 58 "../src/process.vala"
		case GLIBTOP_PROCESS_STOPPED:
#line 261 "process.c"
		{
#line 67 "../src/process.vala"
			usage_process_set_status (self, USAGE_PROCESS_STATUS_SLEEPING);
#line 68 "../src/process.vala"
			break;
#line 267 "process.c"
		}
		default:
#line 58 "../src/process.vala"
		case GLIBTOP_PROCESS_DEAD:
#line 58 "../src/process.vala"
		case GLIBTOP_PROCESS_ZOMBIE:
#line 274 "process.c"
		{
#line 72 "../src/process.vala"
			usage_process_set_status (self, USAGE_PROCESS_STATUS_DEAD);
#line 73 "../src/process.vala"
			break;
#line 280 "process.c"
		}
	}
#line 76 "../src/process.vala"
	_tmp3_ = self->priv->_cpu_load;
#line 76 "../src/process.vala"
	if (_tmp3_ > ((gdouble) 0)) {
#line 77 "../src/process.vala"
		usage_process_set_status (self, USAGE_PROCESS_STATUS_RUNNING);
#line 289 "process.c"
	}
#line 79 "../src/process.vala"
	usage_process_set_mark_as_updated (self, TRUE);
#line 293 "process.c"
}

static guint
_usage_process_get_uid (UsageProcess* self)
{
	guint result = 0U;
	glibtop_proc_uid procUid = {0};
	GPid _tmp0_;
	glibtop_proc_uid _tmp1_ = {0};
	glibtop_proc_uid _tmp2_;
#line 82 "../src/process.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 85 "../src/process.vala"
	_tmp0_ = self->priv->_pid;
#line 85 "../src/process.vala"
	glibtop_get_proc_uid (&_tmp1_, _tmp0_);
#line 85 "../src/process.vala"
	procUid = _tmp1_;
#line 86 "../src/process.vala"
	_tmp2_ = procUid;
#line 86 "../src/process.vala"
	result = (guint) _tmp2_.uid;
#line 86 "../src/process.vala"
	return result;
#line 318 "process.c"
}

gchar*
usage_process_get_full_process_cmd (GPid pid)
{
	gchar* result = NULL;
	glibtop_proc_args proc_args = {0};
	glibtop_proc_state proc_state = {0};
	gchar** args = NULL;
	glibtop_proc_args _tmp0_ = {0};
	gchar** _tmp1_;
	gchar** _tmp2_;
	gint args_length1;
	gint _args_size_;
	glibtop_proc_state _tmp3_ = {0};
	gchar* cmd = NULL;
	glibtop_proc_state _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp19_;
	gchar* _tmp20_;
#line 102 "../src/process.vala"
	_tmp2_ = _tmp1_ = glibtop_get_proc_argv (&_tmp0_, pid, (guint) 0);
#line 102 "../src/process.vala"
	proc_args = _tmp0_;
#line 102 "../src/process.vala"
	args = _tmp2_;
#line 102 "../src/process.vala"
	args_length1 = _vala_array_length (_tmp1_);
#line 102 "../src/process.vala"
	_args_size_ = args_length1;
#line 103 "../src/process.vala"
	glibtop_get_proc_state (&_tmp3_, pid);
#line 103 "../src/process.vala"
	proc_state = _tmp3_;
#line 104 "../src/process.vala"
	_tmp4_ = proc_state;
#line 104 "../src/process.vala"
	_tmp5_ = g_strdup ((const gchar*) _tmp4_.cmd);
#line 104 "../src/process.vala"
	cmd = _tmp5_;
#line 359 "process.c"
	{
		gint i = 0;
#line 109 "../src/process.vala"
		i = 0;
#line 364 "process.c"
		{
			gboolean _tmp6_ = FALSE;
#line 109 "../src/process.vala"
			_tmp6_ = TRUE;
#line 109 "../src/process.vala"
			while (TRUE) {
#line 371 "process.c"
				gchar** _tmp8_;
				gint _tmp8__length1;
				const gchar* _tmp9_;
				gchar* name = NULL;
				gchar** _tmp10_;
				gint _tmp10__length1;
				const gchar* _tmp11_;
				gchar* _tmp12_;
				const gchar* _tmp13_;
				const gchar* _tmp14_;
				const gchar* _tmp15_;
				gchar* _tmp16_;
				const gchar* _tmp17_;
				gchar* _tmp18_;
#line 109 "../src/process.vala"
				if (!_tmp6_) {
#line 388 "process.c"
					gint _tmp7_;
#line 109 "../src/process.vala"
					_tmp7_ = i;
#line 109 "../src/process.vala"
					i = _tmp7_ + 1;
#line 394 "process.c"
				}
#line 109 "../src/process.vala"
				_tmp6_ = FALSE;
#line 109 "../src/process.vala"
				if (!(i < 2)) {
#line 109 "../src/process.vala"
					break;
#line 402 "process.c"
				}
#line 110 "../src/process.vala"
				_tmp8_ = args;
#line 110 "../src/process.vala"
				_tmp8__length1 = args_length1;
#line 110 "../src/process.vala"
				_tmp9_ = _tmp8_[i];
#line 110 "../src/process.vala"
				if (_tmp9_ == NULL) {
#line 111 "../src/process.vala"
					continue;
#line 414 "process.c"
				}
#line 116 "../src/process.vala"
				_tmp10_ = args;
#line 116 "../src/process.vala"
				_tmp10__length1 = args_length1;
#line 116 "../src/process.vala"
				_tmp11_ = _tmp10_[i];
#line 116 "../src/process.vala"
				_tmp12_ = g_path_get_basename (_tmp11_);
#line 116 "../src/process.vala"
				name = _tmp12_;
#line 117 "../src/process.vala"
				_tmp13_ = name;
#line 117 "../src/process.vala"
				_tmp14_ = cmd;
#line 117 "../src/process.vala"
				if (!g_str_has_prefix (_tmp13_, _tmp14_)) {
#line 118 "../src/process.vala"
					_g_free0 (name);
#line 118 "../src/process.vala"
					continue;
#line 436 "process.c"
				}
#line 120 "../src/process.vala"
				_tmp15_ = name;
#line 120 "../src/process.vala"
				_tmp16_ = usage_process_first_component (_tmp15_);
#line 120 "../src/process.vala"
				_g_free0 (name);
#line 120 "../src/process.vala"
				name = _tmp16_;
#line 121 "../src/process.vala"
				_tmp17_ = name;
#line 121 "../src/process.vala"
				_tmp18_ = usage_process_sanitize_name (_tmp17_);
#line 121 "../src/process.vala"
				result = _tmp18_;
#line 121 "../src/process.vala"
				_g_free0 (name);
#line 121 "../src/process.vala"
				_g_free0 (cmd);
#line 121 "../src/process.vala"
				args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 121 "../src/process.vala"
				return result;
#line 460 "process.c"
			}
		}
	}
#line 124 "../src/process.vala"
	_tmp19_ = cmd;
#line 124 "../src/process.vala"
	_tmp20_ = usage_process_sanitize_name (_tmp19_);
#line 124 "../src/process.vala"
	result = _tmp20_;
#line 124 "../src/process.vala"
	_g_free0 (cmd);
#line 124 "../src/process.vala"
	args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_free), NULL);
#line 124 "../src/process.vala"
	return result;
#line 476 "process.c"
}

gchar*
usage_process_read_app_id (GPid pid)
{
	gchar* result = NULL;
	GKeyFile* kf = NULL;
	GKeyFile* _tmp0_;
	GKeyFile* _tmp1_;
	gchar* name = NULL;
	GError* _inner_error0_ = NULL;
#line 128 "../src/process.vala"
	_tmp0_ = usage_process_read_flatpak_info (pid);
#line 128 "../src/process.vala"
	kf = _tmp0_;
#line 130 "../src/process.vala"
	_tmp1_ = kf;
#line 130 "../src/process.vala"
	if (_tmp1_ == NULL) {
#line 131 "../src/process.vala"
		result = NULL;
#line 131 "../src/process.vala"
		_g_key_file_unref0 (kf);
#line 131 "../src/process.vala"
		return result;
#line 502 "process.c"
	}
#line 133 "../src/process.vala"
	name = NULL;
#line 506 "process.c"
	{
		gboolean _tmp2_ = FALSE;
		GKeyFile* _tmp3_;
#line 135 "../src/process.vala"
		_tmp3_ = kf;
#line 135 "../src/process.vala"
		_tmp2_ = g_key_file_has_key (_tmp3_, "Application", "name", &_inner_error0_);
#line 135 "../src/process.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 516 "process.c"
			goto __catch2_g_error;
		}
#line 135 "../src/process.vala"
		if (_tmp2_) {
#line 521 "process.c"
			gchar* _tmp4_ = NULL;
			GKeyFile* _tmp5_;
			gchar* _tmp6_;
			gchar* _tmp7_;
#line 136 "../src/process.vala"
			_tmp5_ = kf;
#line 136 "../src/process.vala"
			_tmp6_ = g_key_file_get_string (_tmp5_, "Application", "name", &_inner_error0_);
#line 136 "../src/process.vala"
			_tmp4_ = _tmp6_;
#line 136 "../src/process.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 534 "process.c"
				goto __catch2_g_error;
			}
#line 136 "../src/process.vala"
			_tmp7_ = _tmp4_;
#line 136 "../src/process.vala"
			_tmp4_ = NULL;
#line 136 "../src/process.vala"
			_g_free0 (name);
#line 136 "../src/process.vala"
			name = _tmp7_;
#line 135 "../src/process.vala"
			_g_free0 (_tmp4_);
#line 547 "process.c"
		}
	}
	goto __finally2;
	__catch2_g_error:
	{
		GError* e = NULL;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
#line 134 "../src/process.vala"
		e = _inner_error0_;
#line 134 "../src/process.vala"
		_inner_error0_ = NULL;
#line 138 "../src/process.vala"
		_tmp8_ = g_strdup_printf ("%i", (gint) pid);
#line 138 "../src/process.vala"
		_tmp9_ = _tmp8_;
#line 138 "../src/process.vala"
		_tmp10_ = g_strconcat ("Failed to parse faltpak info for: ", _tmp9_, NULL);
#line 138 "../src/process.vala"
		_tmp11_ = _tmp10_;
#line 138 "../src/process.vala"
		g_warning ("process.vala:138: %s", _tmp11_);
#line 138 "../src/process.vala"
		_g_free0 (_tmp11_);
#line 138 "../src/process.vala"
		_g_free0 (_tmp9_);
#line 134 "../src/process.vala"
		_g_error_free0 (e);
#line 578 "process.c"
	}
	__finally2:
#line 134 "../src/process.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 134 "../src/process.vala"
		_g_free0 (name);
#line 134 "../src/process.vala"
		_g_key_file_unref0 (kf);
#line 134 "../src/process.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 134 "../src/process.vala"
		g_clear_error (&_inner_error0_);
#line 134 "../src/process.vala"
		return NULL;
#line 593 "process.c"
	}
#line 141 "../src/process.vala"
	result = name;
#line 141 "../src/process.vala"
	_g_key_file_unref0 (kf);
#line 141 "../src/process.vala"
	return result;
#line 601 "process.c"
}

GKeyFile*
usage_process_read_flatpak_info (GPid pid)
{
	GKeyFile* result = NULL;
	gchar* path = NULL;
	gchar* _tmp0_;
	gint flags = 0;
	gint root = 0;
	const gchar* _tmp1_;
	gint fd = 0;
	GKeyFile* kf = NULL;
	GKeyFile* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 145 "../src/process.vala"
	_tmp0_ = g_strdup_printf ("/proc/%u/root", (guint) pid);
#line 145 "../src/process.vala"
	path = _tmp0_;
#line 146 "../src/process.vala"
	flags = (O_RDONLY | O_CLOEXEC) | O_NOCTTY;
#line 148 "../src/process.vala"
	_tmp1_ = path;
#line 148 "../src/process.vala"
	root = openat (AT_FDCWD, _tmp1_, (flags | O_NONBLOCK) | O_DIRECTORY, (mode_t) 0);
#line 150 "../src/process.vala"
	if (root == -1) {
#line 151 "../src/process.vala"
		result = NULL;
#line 151 "../src/process.vala"
		_g_free0 (path);
#line 151 "../src/process.vala"
		return result;
#line 635 "process.c"
	}
#line 153 "../src/process.vala"
	fd = openat (root, ".flatpak-info", flags, (mode_t) 0);
#line 155 "../src/process.vala"
	close (root);
#line 157 "../src/process.vala"
	if (fd == -1) {
#line 158 "../src/process.vala"
		result = NULL;
#line 158 "../src/process.vala"
		_g_free0 (path);
#line 158 "../src/process.vala"
		return result;
#line 649 "process.c"
	}
#line 160 "../src/process.vala"
	_tmp2_ = g_key_file_new ();
#line 160 "../src/process.vala"
	kf = _tmp2_;
#line 655 "process.c"
	{
		gchar* data = NULL;
		gsize len = 0UL;
		GIOChannel* ch = NULL;
		GIOChannel* _tmp3_;
		GIOChannel* _tmp4_;
		GIOStatus status = 0;
		GIOChannel* _tmp5_;
		gchar* _tmp6_ = NULL;
		gsize _tmp7_ = 0UL;
		GIOStatus _tmp8_;
		GIOStatus _tmp9_;
		GKeyFile* _tmp10_;
		const gchar* _tmp11_;
#line 163 "../src/process.vala"
		data = NULL;
#line 167 "../src/process.vala"
		_tmp3_ = g_io_channel_unix_new (fd);
#line 167 "../src/process.vala"
		ch = _tmp3_;
#line 168 "../src/process.vala"
		_tmp4_ = ch;
#line 168 "../src/process.vala"
		g_io_channel_set_close_on_unref (_tmp4_, TRUE);
#line 170 "../src/process.vala"
		_tmp5_ = ch;
#line 170 "../src/process.vala"
		_tmp8_ = g_io_channel_read_to_end (_tmp5_, &_tmp6_, &_tmp7_, &_inner_error0_);
#line 170 "../src/process.vala"
		_g_free0 (data);
#line 170 "../src/process.vala"
		data = _tmp6_;
#line 170 "../src/process.vala"
		len = _tmp7_;
#line 170 "../src/process.vala"
		status = _tmp8_;
#line 170 "../src/process.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 170 "../src/process.vala"
			_g_io_channel_unref0 (ch);
#line 170 "../src/process.vala"
			_g_free0 (data);
#line 698 "process.c"
			goto __catch3_g_error;
		}
#line 171 "../src/process.vala"
		_tmp9_ = status;
#line 171 "../src/process.vala"
		if (_tmp9_ != G_IO_STATUS_NORMAL) {
#line 172 "../src/process.vala"
			result = NULL;
#line 172 "../src/process.vala"
			_g_io_channel_unref0 (ch);
#line 172 "../src/process.vala"
			_g_free0 (data);
#line 172 "../src/process.vala"
			_g_key_file_unref0 (kf);
#line 172 "../src/process.vala"
			_g_free0 (path);
#line 172 "../src/process.vala"
			return result;
#line 717 "process.c"
		}
#line 174 "../src/process.vala"
		_tmp10_ = kf;
#line 174 "../src/process.vala"
		_tmp11_ = data;
#line 174 "../src/process.vala"
		g_key_file_load_from_data (_tmp10_, _tmp11_, len, 0, &_inner_error0_);
#line 174 "../src/process.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 174 "../src/process.vala"
			_g_io_channel_unref0 (ch);
#line 174 "../src/process.vala"
			_g_free0 (data);
#line 731 "process.c"
			goto __catch3_g_error;
		}
#line 162 "../src/process.vala"
		_g_io_channel_unref0 (ch);
#line 162 "../src/process.vala"
		_g_free0 (data);
#line 738 "process.c"
	}
	goto __finally3;
	__catch3_g_error:
	{
		GError* e = NULL;
#line 162 "../src/process.vala"
		e = _inner_error0_;
#line 162 "../src/process.vala"
		_inner_error0_ = NULL;
#line 176 "../src/process.vala"
		result = NULL;
#line 176 "../src/process.vala"
		_g_error_free0 (e);
#line 176 "../src/process.vala"
		_g_key_file_unref0 (kf);
#line 176 "../src/process.vala"
		_g_free0 (path);
#line 176 "../src/process.vala"
		return result;
#line 758 "process.c"
	}
	__finally3:
#line 162 "../src/process.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 162 "../src/process.vala"
		_g_key_file_unref0 (kf);
#line 162 "../src/process.vala"
		_g_free0 (path);
#line 162 "../src/process.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 162 "../src/process.vala"
		g_clear_error (&_inner_error0_);
#line 162 "../src/process.vala"
		return NULL;
#line 773 "process.c"
	}
#line 179 "../src/process.vala"
	result = kf;
#line 179 "../src/process.vala"
	_g_free0 (path);
#line 179 "../src/process.vala"
	return result;
#line 781 "process.c"
}

gchar*
usage_process_sanitize_name (const gchar* name)
{
	gchar* result = NULL;
	gchar* _result_ = NULL;
	GError* _inner_error0_ = NULL;
#line 183 "../src/process.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 184 "../src/process.vala"
	_result_ = NULL;
#line 186 "../src/process.vala"
	if (name == NULL) {
#line 187 "../src/process.vala"
		result = NULL;
#line 187 "../src/process.vala"
		_g_free0 (_result_);
#line 187 "../src/process.vala"
		return result;
#line 802 "process.c"
	}
	{
		GRegex* rgx = NULL;
		GRegex* _tmp0_;
		gchar* _tmp1_ = NULL;
		GRegex* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 190 "../src/process.vala"
		_tmp0_ = g_regex_new ("[^a-zA-Z0-9._-]", 0, 0, &_inner_error0_);
#line 190 "../src/process.vala"
		rgx = _tmp0_;
#line 190 "../src/process.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 190 "../src/process.vala"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 821 "process.c"
				goto __catch4_g_regex_error;
			}
#line 190 "../src/process.vala"
			_g_free0 (_result_);
#line 190 "../src/process.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 190 "../src/process.vala"
			g_clear_error (&_inner_error0_);
#line 190 "../src/process.vala"
			return NULL;
#line 832 "process.c"
		}
#line 191 "../src/process.vala"
		_tmp2_ = rgx;
#line 191 "../src/process.vala"
		_tmp3_ = strlen (name);
#line 191 "../src/process.vala"
		_tmp4_ = _tmp3_;
#line 191 "../src/process.vala"
		_tmp5_ = g_regex_replace (_tmp2_, name, (gssize) _tmp4_, 0, "", 0, &_inner_error0_);
#line 191 "../src/process.vala"
		_tmp1_ = _tmp5_;
#line 191 "../src/process.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 191 "../src/process.vala"
			_g_regex_unref0 (rgx);
#line 191 "../src/process.vala"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 850 "process.c"
				goto __catch4_g_regex_error;
			}
#line 191 "../src/process.vala"
			_g_regex_unref0 (rgx);
#line 191 "../src/process.vala"
			_g_free0 (_result_);
#line 191 "../src/process.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 191 "../src/process.vala"
			g_clear_error (&_inner_error0_);
#line 191 "../src/process.vala"
			return NULL;
#line 863 "process.c"
		}
#line 191 "../src/process.vala"
		_tmp6_ = _tmp1_;
#line 191 "../src/process.vala"
		_tmp1_ = NULL;
#line 191 "../src/process.vala"
		_g_free0 (_result_);
#line 191 "../src/process.vala"
		_result_ = _tmp6_;
#line 189 "../src/process.vala"
		_g_free0 (_tmp1_);
#line 189 "../src/process.vala"
		_g_regex_unref0 (rgx);
#line 877 "process.c"
	}
	goto __finally4;
	__catch4_g_regex_error:
	{
		GError* e = NULL;
		GError* _tmp7_;
		const gchar* _tmp8_;
#line 189 "../src/process.vala"
		e = _inner_error0_;
#line 189 "../src/process.vala"
		_inner_error0_ = NULL;
#line 193 "../src/process.vala"
		_tmp7_ = e;
#line 193 "../src/process.vala"
		_tmp8_ = _tmp7_->message;
#line 193 "../src/process.vala"
		g_warning ("process.vala:193: Unable to sanitize name: %s", _tmp8_);
#line 189 "../src/process.vala"
		_g_error_free0 (e);
#line 897 "process.c"
	}
	__finally4:
#line 189 "../src/process.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 189 "../src/process.vala"
		_g_free0 (_result_);
#line 189 "../src/process.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 189 "../src/process.vala"
		g_clear_error (&_inner_error0_);
#line 189 "../src/process.vala"
		return NULL;
#line 910 "process.c"
	}
#line 196 "../src/process.vala"
	result = _result_;
#line 196 "../src/process.vala"
	return result;
#line 916 "process.c"
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar result = '\0';
	gchar _tmp0_;
#line 1180 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1181 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1181 "glib-2.0.vapi"
	result = _tmp0_;
#line 1181 "glib-2.0.vapi"
	return result;
#line 933 "process.c"
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	glong result = 0L;
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 1395 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1395 "glib-2.0.vapi"
	end = _tmp0_;
#line 1396 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1396 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1397 "glib-2.0.vapi"
		result = maxlen;
#line 1397 "glib-2.0.vapi"
		return result;
#line 956 "process.c"
	} else {
		gchar* _tmp2_;
#line 1399 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1399 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1399 "glib-2.0.vapi"
		return result;
#line 965 "process.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	gchar* result = NULL;
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
#line 1406 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1408 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1408 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 984 "process.c"
	} else {
#line 1408 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 988 "process.c"
	}
#line 1408 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1410 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 994 "process.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1412 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1412 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1412 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 1004 "process.c"
	}
#line 1415 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1416 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1417 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 1012 "process.c"
	} else {
#line 1419 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 1016 "process.c"
	}
#line 1421 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1422 "glib-2.0.vapi"
		len = string_length - offset;
#line 1022 "process.c"
	}
#line 1424 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1425 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1425 "glib-2.0.vapi"
	result = _tmp3_;
#line 1425 "glib-2.0.vapi"
	return result;
#line 1032 "process.c"
}

gchar*
usage_process_first_component (const gchar* str)
{
	gchar* result = NULL;
	gchar* _tmp5_;
#line 199 "../src/process.vala"
	g_return_val_if_fail (str != NULL, NULL);
#line 1042 "process.c"
	{
		gint i = 0;
#line 201 "../src/process.vala"
		i = 0;
#line 1047 "process.c"
		{
			gboolean _tmp0_ = FALSE;
#line 201 "../src/process.vala"
			_tmp0_ = TRUE;
#line 201 "../src/process.vala"
			while (TRUE) {
#line 1054 "process.c"
				gint _tmp2_;
				gint _tmp3_;
#line 201 "../src/process.vala"
				if (!_tmp0_) {
#line 1059 "process.c"
					gint _tmp1_;
#line 201 "../src/process.vala"
					_tmp1_ = i;
#line 201 "../src/process.vala"
					i = _tmp1_ + 1;
#line 1065 "process.c"
				}
#line 201 "../src/process.vala"
				_tmp0_ = FALSE;
#line 201 "../src/process.vala"
				_tmp2_ = strlen (str);
#line 201 "../src/process.vala"
				_tmp3_ = _tmp2_;
#line 201 "../src/process.vala"
				if (!(i < _tmp3_)) {
#line 201 "../src/process.vala"
					break;
#line 1077 "process.c"
				}
#line 202 "../src/process.vala"
				if (string_get (str, (glong) i) == ' ') {
#line 1081 "process.c"
					gchar* _tmp4_;
#line 203 "../src/process.vala"
					_tmp4_ = string_substring (str, (glong) 0, (glong) i);
#line 203 "../src/process.vala"
					result = _tmp4_;
#line 203 "../src/process.vala"
					return result;
#line 1089 "process.c"
				}
			}
		}
	}
#line 207 "../src/process.vala"
	_tmp5_ = g_strdup (str);
#line 207 "../src/process.vala"
	result = _tmp5_;
#line 207 "../src/process.vala"
	return result;
#line 1100 "process.c"
}

GPid
usage_process_get_pid (UsageProcess* self)
{
	GPid result;
#line 25 "../src/process.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 25 "../src/process.vala"
	result = self->priv->_pid;
#line 25 "../src/process.vala"
	return result;
#line 1113 "process.c"
}

static void
usage_process_set_pid (UsageProcess* self,
                       GPid value)
{
#line 25 "../src/process.vala"
	g_return_if_fail (self != NULL);
#line 25 "../src/process.vala"
	if (usage_process_get_pid (self) != value) {
#line 25 "../src/process.vala"
		self->priv->_pid = value;
#line 25 "../src/process.vala"
		g_object_notify_by_pspec ((GObject *) self, usage_process_properties[USAGE_PROCESS_PID_PROPERTY]);
#line 1128 "process.c"
	}
}

const gchar*
usage_process_get_cmdline (UsageProcess* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 26 "../src/process.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 26 "../src/process.vala"
	_tmp0_ = self->priv->_cmdline;
#line 26 "../src/process.vala"
	result = _tmp0_;
#line 26 "../src/process.vala"
	return result;
#line 1145 "process.c"
}

static void
usage_process_set_cmdline (UsageProcess* self,
                           const gchar* value)
{
#line 26 "../src/process.vala"
	g_return_if_fail (self != NULL);
#line 26 "../src/process.vala"
	if (g_strcmp0 (value, usage_process_get_cmdline (self)) != 0) {
#line 1156 "process.c"
		gchar* _tmp0_;
#line 26 "../src/process.vala"
		_tmp0_ = g_strdup (value);
#line 26 "../src/process.vala"
		_g_free0 (self->priv->_cmdline);
#line 26 "../src/process.vala"
		self->priv->_cmdline = _tmp0_;
#line 26 "../src/process.vala"
		g_object_notify_by_pspec ((GObject *) self, usage_process_properties[USAGE_PROCESS_CMDLINE_PROPERTY]);
#line 1166 "process.c"
	}
}

guint
usage_process_get_uid (UsageProcess* self)
{
	guint result;
#line 27 "../src/process.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 27 "../src/process.vala"
	result = self->priv->_uid;
#line 27 "../src/process.vala"
	return result;
#line 1180 "process.c"
}

static void
usage_process_set_uid (UsageProcess* self,
                       guint value)
{
#line 27 "../src/process.vala"
	g_return_if_fail (self != NULL);
#line 27 "../src/process.vala"
	if (usage_process_get_uid (self) != value) {
#line 27 "../src/process.vala"
		self->priv->_uid = value;
#line 27 "../src/process.vala"
		g_object_notify_by_pspec ((GObject *) self, usage_process_properties[USAGE_PROCESS_UID_PROPERTY]);
#line 1195 "process.c"
	}
}

guint64
usage_process_get_start_time (UsageProcess* self)
{
	guint64 result;
#line 28 "../src/process.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 28 "../src/process.vala"
	result = self->priv->_start_time;
#line 28 "../src/process.vala"
	return result;
#line 1209 "process.c"
}

void
usage_process_set_start_time (UsageProcess* self,
                              guint64 value)
{
#line 28 "../src/process.vala"
	g_return_if_fail (self != NULL);
#line 28 "../src/process.vala"
	if (usage_process_get_start_time (self) != value) {
#line 28 "../src/process.vala"
		self->priv->_start_time = value;
#line 28 "../src/process.vala"
		g_object_notify_by_pspec ((GObject *) self, usage_process_properties[USAGE_PROCESS_START_TIME_PROPERTY]);
#line 1224 "process.c"
	}
}

gdouble
usage_process_get_cpu_load (UsageProcess* self)
{
	gdouble result;
#line 30 "../src/process.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 30 "../src/process.vala"
	result = self->priv->_cpu_load;
#line 30 "../src/process.vala"
	return result;
#line 1238 "process.c"
}

void
usage_process_set_cpu_load (UsageProcess* self,
                            gdouble value)
{
#line 30 "../src/process.vala"
	g_return_if_fail (self != NULL);
#line 30 "../src/process.vala"
	if (usage_process_get_cpu_load (self) != value) {
#line 30 "../src/process.vala"
		self->priv->_cpu_load = value;
#line 30 "../src/process.vala"
		g_object_notify_by_pspec ((GObject *) self, usage_process_properties[USAGE_PROCESS_CPU_LOAD_PROPERTY]);
#line 1253 "process.c"
	}
}

gdouble
usage_process_get_x_cpu_load (UsageProcess* self)
{
	gdouble result;
#line 31 "../src/process.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 31 "../src/process.vala"
	result = self->priv->_x_cpu_load;
#line 31 "../src/process.vala"
	return result;
#line 1267 "process.c"
}

void
usage_process_set_x_cpu_load (UsageProcess* self,
                              gdouble value)
{
#line 31 "../src/process.vala"
	g_return_if_fail (self != NULL);
#line 31 "../src/process.vala"
	if (usage_process_get_x_cpu_load (self) != value) {
#line 31 "../src/process.vala"
		self->priv->_x_cpu_load = value;
#line 31 "../src/process.vala"
		g_object_notify_by_pspec ((GObject *) self, usage_process_properties[USAGE_PROCESS_X_CPU_LOAD_PROPERTY]);
#line 1282 "process.c"
	}
}

guint64
usage_process_get_cpu_last_used (UsageProcess* self)
{
	guint64 result;
#line 32 "../src/process.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 32 "../src/process.vala"
	result = self->priv->_cpu_last_used;
#line 32 "../src/process.vala"
	return result;
#line 1296 "process.c"
}

void
usage_process_set_cpu_last_used (UsageProcess* self,
                                 guint64 value)
{
#line 32 "../src/process.vala"
	g_return_if_fail (self != NULL);
#line 32 "../src/process.vala"
	if (usage_process_get_cpu_last_used (self) != value) {
#line 32 "../src/process.vala"
		self->priv->_cpu_last_used = value;
#line 32 "../src/process.vala"
		g_object_notify_by_pspec ((GObject *) self, usage_process_properties[USAGE_PROCESS_CPU_LAST_USED_PROPERTY]);
#line 1311 "process.c"
	}
}

guint64
usage_process_get_x_cpu_last_used (UsageProcess* self)
{
	guint64 result;
#line 33 "../src/process.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 33 "../src/process.vala"
	result = self->priv->_x_cpu_last_used;
#line 33 "../src/process.vala"
	return result;
#line 1325 "process.c"
}

void
usage_process_set_x_cpu_last_used (UsageProcess* self,
                                   guint64 value)
{
#line 33 "../src/process.vala"
	g_return_if_fail (self != NULL);
#line 33 "../src/process.vala"
	if (usage_process_get_x_cpu_last_used (self) != value) {
#line 33 "../src/process.vala"
		self->priv->_x_cpu_last_used = value;
#line 33 "../src/process.vala"
		g_object_notify_by_pspec ((GObject *) self, usage_process_properties[USAGE_PROCESS_X_CPU_LAST_USED_PROPERTY]);
#line 1340 "process.c"
	}
}

guint
usage_process_get_last_processor (UsageProcess* self)
{
	guint result;
#line 34 "../src/process.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 34 "../src/process.vala"
	result = self->priv->_last_processor;
#line 34 "../src/process.vala"
	return result;
#line 1354 "process.c"
}

void
usage_process_set_last_processor (UsageProcess* self,
                                  guint value)
{
#line 34 "../src/process.vala"
	g_return_if_fail (self != NULL);
#line 34 "../src/process.vala"
	if (usage_process_get_last_processor (self) != value) {
#line 34 "../src/process.vala"
		self->priv->_last_processor = value;
#line 34 "../src/process.vala"
		g_object_notify_by_pspec ((GObject *) self, usage_process_properties[USAGE_PROCESS_LAST_PROCESSOR_PROPERTY]);
#line 1369 "process.c"
	}
}

guint64
usage_process_get_mem_usage (UsageProcess* self)
{
	guint64 result;
#line 36 "../src/process.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 36 "../src/process.vala"
	result = self->priv->_mem_usage;
#line 36 "../src/process.vala"
	return result;
#line 1383 "process.c"
}

void
usage_process_set_mem_usage (UsageProcess* self,
                             guint64 value)
{
#line 36 "../src/process.vala"
	g_return_if_fail (self != NULL);
#line 36 "../src/process.vala"
	if (usage_process_get_mem_usage (self) != value) {
#line 36 "../src/process.vala"
		self->priv->_mem_usage = value;
#line 36 "../src/process.vala"
		g_object_notify_by_pspec ((GObject *) self, usage_process_properties[USAGE_PROCESS_MEM_USAGE_PROPERTY]);
#line 1398 "process.c"
	}
}

gboolean
usage_process_get_gamemode (UsageProcess* self)
{
	gboolean result;
#line 38 "../src/process.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 38 "../src/process.vala"
	result = self->priv->_gamemode;
#line 38 "../src/process.vala"
	return result;
#line 1412 "process.c"
}

void
usage_process_set_gamemode (UsageProcess* self,
                            gboolean value)
{
#line 38 "../src/process.vala"
	g_return_if_fail (self != NULL);
#line 38 "../src/process.vala"
	if (usage_process_get_gamemode (self) != value) {
#line 38 "../src/process.vala"
		self->priv->_gamemode = value;
#line 38 "../src/process.vala"
		g_object_notify_by_pspec ((GObject *) self, usage_process_properties[USAGE_PROCESS_GAMEMODE_PROPERTY]);
#line 1427 "process.c"
	}
}

gboolean
usage_process_get_mark_as_updated (UsageProcess* self)
{
	gboolean result;
#line 40 "../src/process.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 40 "../src/process.vala"
	result = self->priv->_mark_as_updated;
#line 40 "../src/process.vala"
	return result;
#line 1441 "process.c"
}

void
usage_process_set_mark_as_updated (UsageProcess* self,
                                   gboolean value)
{
#line 40 "../src/process.vala"
	g_return_if_fail (self != NULL);
#line 40 "../src/process.vala"
	if (usage_process_get_mark_as_updated (self) != value) {
#line 40 "../src/process.vala"
		self->priv->_mark_as_updated = value;
#line 40 "../src/process.vala"
		g_object_notify_by_pspec ((GObject *) self, usage_process_properties[USAGE_PROCESS_MARK_AS_UPDATED_PROPERTY]);
#line 1456 "process.c"
	}
}

UsageProcessStatus
usage_process_get_status (UsageProcess* self)
{
	UsageProcessStatus result;
	UsageProcessStatus _tmp0_;
#line 41 "../src/process.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 41 "../src/process.vala"
	_tmp0_ = self->priv->_status;
#line 41 "../src/process.vala"
	result = _tmp0_;
#line 41 "../src/process.vala"
	return result;
#line 1473 "process.c"
}

static void
usage_process_set_status (UsageProcess* self,
                          UsageProcessStatus value)
{
#line 41 "../src/process.vala"
	g_return_if_fail (self != NULL);
#line 41 "../src/process.vala"
	if (usage_process_get_status (self) != value) {
#line 41 "../src/process.vala"
		self->priv->_status = value;
#line 41 "../src/process.vala"
		g_object_notify_by_pspec ((GObject *) self, usage_process_properties[USAGE_PROCESS_STATUS_PROPERTY]);
#line 1488 "process.c"
	}
}

const gchar*
usage_process_get_app_id (UsageProcess* self)
{
	const gchar* result;
	const gchar* _tmp2_;
#line 90 "../src/process.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 91 "../src/process.vala"
	if (!self->priv->_app_id_checked) {
#line 1501 "process.c"
		GPid _tmp0_;
		gchar* _tmp1_;
#line 92 "../src/process.vala"
		_tmp0_ = self->priv->_pid;
#line 92 "../src/process.vala"
		_tmp1_ = usage_process_read_app_id (_tmp0_);
#line 92 "../src/process.vala"
		_g_free0 (self->priv->_app_id);
#line 92 "../src/process.vala"
		self->priv->_app_id = _tmp1_;
#line 1512 "process.c"
	}
#line 94 "../src/process.vala"
	_tmp2_ = self->priv->_app_id;
#line 94 "../src/process.vala"
	result = _tmp2_;
#line 94 "../src/process.vala"
	return result;
#line 1520 "process.c"
}

static void
usage_process_class_init (UsageProcessClass * klass,
                          gpointer klass_data)
{
#line 23 "../src/process.vala"
	usage_process_parent_class = g_type_class_peek_parent (klass);
#line 23 "../src/process.vala"
	g_type_class_adjust_private_offset (klass, &UsageProcess_private_offset);
#line 23 "../src/process.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_usage_process_get_property;
#line 23 "../src/process.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_usage_process_set_property;
#line 23 "../src/process.vala"
	G_OBJECT_CLASS (klass)->finalize = usage_process_finalize;
#line 23 "../src/process.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), USAGE_PROCESS_PID_PROPERTY, usage_process_properties[USAGE_PROCESS_PID_PROPERTY] = g_param_spec_int ("pid", "pid", "pid", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 23 "../src/process.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), USAGE_PROCESS_CMDLINE_PROPERTY, usage_process_properties[USAGE_PROCESS_CMDLINE_PROPERTY] = g_param_spec_string ("cmdline", "cmdline", "cmdline", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 23 "../src/process.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), USAGE_PROCESS_UID_PROPERTY, usage_process_properties[USAGE_PROCESS_UID_PROPERTY] = g_param_spec_uint ("uid", "uid", "uid", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 23 "../src/process.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), USAGE_PROCESS_START_TIME_PROPERTY, usage_process_properties[USAGE_PROCESS_START_TIME_PROPERTY] = g_param_spec_uint64 ("start-time", "start-time", "start-time", 0, G_MAXUINT64, (guint64) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "../src/process.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), USAGE_PROCESS_CPU_LOAD_PROPERTY, usage_process_properties[USAGE_PROCESS_CPU_LOAD_PROPERTY] = g_param_spec_double ("cpu-load", "cpu-load", "cpu-load", -G_MAXDOUBLE, G_MAXDOUBLE, (gdouble) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "../src/process.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), USAGE_PROCESS_X_CPU_LOAD_PROPERTY, usage_process_properties[USAGE_PROCESS_X_CPU_LOAD_PROPERTY] = g_param_spec_double ("x-cpu-load", "x-cpu-load", "x-cpu-load", -G_MAXDOUBLE, G_MAXDOUBLE, (gdouble) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "../src/process.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), USAGE_PROCESS_CPU_LAST_USED_PROPERTY, usage_process_properties[USAGE_PROCESS_CPU_LAST_USED_PROPERTY] = g_param_spec_uint64 ("cpu-last-used", "cpu-last-used", "cpu-last-used", 0, G_MAXUINT64, (guint64) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "../src/process.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), USAGE_PROCESS_X_CPU_LAST_USED_PROPERTY, usage_process_properties[USAGE_PROCESS_X_CPU_LAST_USED_PROPERTY] = g_param_spec_uint64 ("x-cpu-last-used", "x-cpu-last-used", "x-cpu-last-used", 0, G_MAXUINT64, (guint64) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "../src/process.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), USAGE_PROCESS_LAST_PROCESSOR_PROPERTY, usage_process_properties[USAGE_PROCESS_LAST_PROCESSOR_PROPERTY] = g_param_spec_uint ("last-processor", "last-processor", "last-processor", 0, G_MAXUINT, (guint) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "../src/process.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), USAGE_PROCESS_MEM_USAGE_PROPERTY, usage_process_properties[USAGE_PROCESS_MEM_USAGE_PROPERTY] = g_param_spec_uint64 ("mem-usage", "mem-usage", "mem-usage", 0, G_MAXUINT64, (guint64) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "../src/process.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), USAGE_PROCESS_GAMEMODE_PROPERTY, usage_process_properties[USAGE_PROCESS_GAMEMODE_PROPERTY] = g_param_spec_boolean ("gamemode", "gamemode", "gamemode", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "../src/process.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), USAGE_PROCESS_MARK_AS_UPDATED_PROPERTY, usage_process_properties[USAGE_PROCESS_MARK_AS_UPDATED_PROPERTY] = g_param_spec_boolean ("mark-as-updated", "mark-as-updated", "mark-as-updated", TRUE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 23 "../src/process.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), USAGE_PROCESS_STATUS_PROPERTY, usage_process_properties[USAGE_PROCESS_STATUS_PROPERTY] = g_param_spec_enum ("status", "status", "status", USAGE_TYPE_PROCESS_STATUS, USAGE_PROCESS_STATUS_SLEEPING, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 23 "../src/process.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), USAGE_PROCESS_APP_ID_PROPERTY, usage_process_properties[USAGE_PROCESS_APP_ID_PROPERTY] = g_param_spec_string ("app-id", "app-id", "app-id", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1565 "process.c"
}

static void
usage_process_instance_init (UsageProcess * self,
                             gpointer klass)
{
#line 23 "../src/process.vala"
	self->priv = usage_process_get_instance_private (self);
#line 28 "../src/process.vala"
	self->priv->_start_time = (guint64) 0;
#line 30 "../src/process.vala"
	self->priv->_cpu_load = (gdouble) 0;
#line 31 "../src/process.vala"
	self->priv->_x_cpu_load = (gdouble) 0;
#line 32 "../src/process.vala"
	self->priv->_cpu_last_used = (guint64) 0;
#line 33 "../src/process.vala"
	self->priv->_x_cpu_last_used = (guint64) 0;
#line 34 "../src/process.vala"
	self->priv->_last_processor = (guint) 0;
#line 36 "../src/process.vala"
	self->priv->_mem_usage = (guint64) 0;
#line 40 "../src/process.vala"
	self->priv->_mark_as_updated = TRUE;
#line 41 "../src/process.vala"
	self->priv->_status = USAGE_PROCESS_STATUS_SLEEPING;
#line 43 "../src/process.vala"
	self->priv->_app_id = NULL;
#line 44 "../src/process.vala"
	self->priv->_app_id_checked = FALSE;
#line 1596 "process.c"
}

static void
usage_process_finalize (GObject * obj)
{
	UsageProcess * self;
#line 23 "../src/process.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, USAGE_TYPE_PROCESS, UsageProcess);
#line 26 "../src/process.vala"
	_g_free0 (self->priv->_cmdline);
#line 43 "../src/process.vala"
	_g_free0 (self->priv->_app_id);
#line 23 "../src/process.vala"
	G_OBJECT_CLASS (usage_process_parent_class)->finalize (obj);
#line 1611 "process.c"
}

GType
usage_process_get_type (void)
{
	static volatile gsize usage_process_type_id__volatile = 0;
	if (g_once_init_enter (&usage_process_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (UsageProcessClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) usage_process_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UsageProcess), 0, (GInstanceInitFunc) usage_process_instance_init, NULL };
		GType usage_process_type_id;
		usage_process_type_id = g_type_register_static (G_TYPE_OBJECT, "UsageProcess", &g_define_type_info, 0);
		UsageProcess_private_offset = g_type_add_instance_private (usage_process_type_id, sizeof (UsageProcessPrivate));
		g_once_init_leave (&usage_process_type_id__volatile, usage_process_type_id);
	}
	return usage_process_type_id__volatile;
}

static void
_vala_usage_process_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec)
{
	UsageProcess * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, USAGE_TYPE_PROCESS, UsageProcess);
#line 23 "../src/process.vala"
	switch (property_id) {
#line 23 "../src/process.vala"
		case USAGE_PROCESS_PID_PROPERTY:
#line 23 "../src/process.vala"
		g_value_set_int (value, usage_process_get_pid (self));
#line 23 "../src/process.vala"
		break;
#line 23 "../src/process.vala"
		case USAGE_PROCESS_CMDLINE_PROPERTY:
#line 23 "../src/process.vala"
		g_value_set_string (value, usage_process_get_cmdline (self));
#line 23 "../src/process.vala"
		break;
#line 23 "../src/process.vala"
		case USAGE_PROCESS_UID_PROPERTY:
#line 23 "../src/process.vala"
		g_value_set_uint (value, usage_process_get_uid (self));
#line 23 "../src/process.vala"
		break;
#line 23 "../src/process.vala"
		case USAGE_PROCESS_START_TIME_PROPERTY:
#line 23 "../src/process.vala"
		g_value_set_uint64 (value, usage_process_get_start_time (self));
#line 23 "../src/process.vala"
		break;
#line 23 "../src/process.vala"
		case USAGE_PROCESS_CPU_LOAD_PROPERTY:
#line 23 "../src/process.vala"
		g_value_set_double (value, usage_process_get_cpu_load (self));
#line 23 "../src/process.vala"
		break;
#line 23 "../src/process.vala"
		case USAGE_PROCESS_X_CPU_LOAD_PROPERTY:
#line 23 "../src/process.vala"
		g_value_set_double (value, usage_process_get_x_cpu_load (self));
#line 23 "../src/process.vala"
		break;
#line 23 "../src/process.vala"
		case USAGE_PROCESS_CPU_LAST_USED_PROPERTY:
#line 23 "../src/process.vala"
		g_value_set_uint64 (value, usage_process_get_cpu_last_used (self));
#line 23 "../src/process.vala"
		break;
#line 23 "../src/process.vala"
		case USAGE_PROCESS_X_CPU_LAST_USED_PROPERTY:
#line 23 "../src/process.vala"
		g_value_set_uint64 (value, usage_process_get_x_cpu_last_used (self));
#line 23 "../src/process.vala"
		break;
#line 23 "../src/process.vala"
		case USAGE_PROCESS_LAST_PROCESSOR_PROPERTY:
#line 23 "../src/process.vala"
		g_value_set_uint (value, usage_process_get_last_processor (self));
#line 23 "../src/process.vala"
		break;
#line 23 "../src/process.vala"
		case USAGE_PROCESS_MEM_USAGE_PROPERTY:
#line 23 "../src/process.vala"
		g_value_set_uint64 (value, usage_process_get_mem_usage (self));
#line 23 "../src/process.vala"
		break;
#line 23 "../src/process.vala"
		case USAGE_PROCESS_GAMEMODE_PROPERTY:
#line 23 "../src/process.vala"
		g_value_set_boolean (value, usage_process_get_gamemode (self));
#line 23 "../src/process.vala"
		break;
#line 23 "../src/process.vala"
		case USAGE_PROCESS_MARK_AS_UPDATED_PROPERTY:
#line 23 "../src/process.vala"
		g_value_set_boolean (value, usage_process_get_mark_as_updated (self));
#line 23 "../src/process.vala"
		break;
#line 23 "../src/process.vala"
		case USAGE_PROCESS_STATUS_PROPERTY:
#line 23 "../src/process.vala"
		g_value_set_enum (value, usage_process_get_status (self));
#line 23 "../src/process.vala"
		break;
#line 23 "../src/process.vala"
		case USAGE_PROCESS_APP_ID_PROPERTY:
#line 23 "../src/process.vala"
		g_value_set_string (value, usage_process_get_app_id (self));
#line 23 "../src/process.vala"
		break;
#line 1722 "process.c"
		default:
#line 23 "../src/process.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../src/process.vala"
		break;
#line 1728 "process.c"
	}
}

static void
_vala_usage_process_set_property (GObject * object,
                                  guint property_id,
                                  const GValue * value,
                                  GParamSpec * pspec)
{
	UsageProcess * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, USAGE_TYPE_PROCESS, UsageProcess);
#line 23 "../src/process.vala"
	switch (property_id) {
#line 23 "../src/process.vala"
		case USAGE_PROCESS_PID_PROPERTY:
#line 23 "../src/process.vala"
		usage_process_set_pid (self, g_value_get_int (value));
#line 23 "../src/process.vala"
		break;
#line 23 "../src/process.vala"
		case USAGE_PROCESS_CMDLINE_PROPERTY:
#line 23 "../src/process.vala"
		usage_process_set_cmdline (self, g_value_get_string (value));
#line 23 "../src/process.vala"
		break;
#line 23 "../src/process.vala"
		case USAGE_PROCESS_UID_PROPERTY:
#line 23 "../src/process.vala"
		usage_process_set_uid (self, g_value_get_uint (value));
#line 23 "../src/process.vala"
		break;
#line 23 "../src/process.vala"
		case USAGE_PROCESS_START_TIME_PROPERTY:
#line 23 "../src/process.vala"
		usage_process_set_start_time (self, g_value_get_uint64 (value));
#line 23 "../src/process.vala"
		break;
#line 23 "../src/process.vala"
		case USAGE_PROCESS_CPU_LOAD_PROPERTY:
#line 23 "../src/process.vala"
		usage_process_set_cpu_load (self, g_value_get_double (value));
#line 23 "../src/process.vala"
		break;
#line 23 "../src/process.vala"
		case USAGE_PROCESS_X_CPU_LOAD_PROPERTY:
#line 23 "../src/process.vala"
		usage_process_set_x_cpu_load (self, g_value_get_double (value));
#line 23 "../src/process.vala"
		break;
#line 23 "../src/process.vala"
		case USAGE_PROCESS_CPU_LAST_USED_PROPERTY:
#line 23 "../src/process.vala"
		usage_process_set_cpu_last_used (self, g_value_get_uint64 (value));
#line 23 "../src/process.vala"
		break;
#line 23 "../src/process.vala"
		case USAGE_PROCESS_X_CPU_LAST_USED_PROPERTY:
#line 23 "../src/process.vala"
		usage_process_set_x_cpu_last_used (self, g_value_get_uint64 (value));
#line 23 "../src/process.vala"
		break;
#line 23 "../src/process.vala"
		case USAGE_PROCESS_LAST_PROCESSOR_PROPERTY:
#line 23 "../src/process.vala"
		usage_process_set_last_processor (self, g_value_get_uint (value));
#line 23 "../src/process.vala"
		break;
#line 23 "../src/process.vala"
		case USAGE_PROCESS_MEM_USAGE_PROPERTY:
#line 23 "../src/process.vala"
		usage_process_set_mem_usage (self, g_value_get_uint64 (value));
#line 23 "../src/process.vala"
		break;
#line 23 "../src/process.vala"
		case USAGE_PROCESS_GAMEMODE_PROPERTY:
#line 23 "../src/process.vala"
		usage_process_set_gamemode (self, g_value_get_boolean (value));
#line 23 "../src/process.vala"
		break;
#line 23 "../src/process.vala"
		case USAGE_PROCESS_MARK_AS_UPDATED_PROPERTY:
#line 23 "../src/process.vala"
		usage_process_set_mark_as_updated (self, g_value_get_boolean (value));
#line 23 "../src/process.vala"
		break;
#line 23 "../src/process.vala"
		case USAGE_PROCESS_STATUS_PROPERTY:
#line 23 "../src/process.vala"
		usage_process_set_status (self, g_value_get_enum (value));
#line 23 "../src/process.vala"
		break;
#line 1820 "process.c"
		default:
#line 23 "../src/process.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../src/process.vala"
		break;
#line 1826 "process.c"
	}
}

GType
usage_process_status_get_type (void)
{
	static volatile gsize usage_process_status_type_id__volatile = 0;
	if (g_once_init_enter (&usage_process_status_type_id__volatile)) {
		static const GEnumValue values[] = {{USAGE_PROCESS_STATUS_RUNNING, "USAGE_PROCESS_STATUS_RUNNING", "running"}, {USAGE_PROCESS_STATUS_SLEEPING, "USAGE_PROCESS_STATUS_SLEEPING", "sleeping"}, {USAGE_PROCESS_STATUS_DEAD, "USAGE_PROCESS_STATUS_DEAD", "dead"}, {0, NULL, NULL}};
		GType usage_process_status_type_id;
		usage_process_status_type_id = g_enum_register_static ("UsageProcessStatus", values);
		g_once_init_leave (&usage_process_status_type_id__volatile, usage_process_status_type_id);
	}
	return usage_process_status_type_id__volatile;
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

