/* storage-view-item.c generated by valac 0.45.3, the Vala compiler
 * generated from storage-view-item.vala, do not modify */

/* storage-view-item.vala
 *
 * Copyright (C) 2018 Red Hat, Inc.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors: Felipe Borges <felipeborges@gnome.org>
 *          Petr Štětka <pstetka@redhat.com>
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>

typedef enum  {
	STORAGE_VIEW_TYPE_NONE,
	STORAGE_VIEW_TYPE_OS,
	STORAGE_VIEW_TYPE_UP_FOLDER,
	STORAGE_VIEW_TYPE_AVAILABLE_GRAPH,
	STORAGE_VIEW_TYPE_ROOT_ITEM
} StorageViewType;

#define TYPE_STORAGE_VIEW_TYPE (storage_view_type_get_type ())

#define USAGE_TYPE_STORAGE_VIEW_ITEM (usage_storage_view_item_get_type ())
#define USAGE_STORAGE_VIEW_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), USAGE_TYPE_STORAGE_VIEW_ITEM, UsageStorageViewItem))
#define USAGE_STORAGE_VIEW_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), USAGE_TYPE_STORAGE_VIEW_ITEM, UsageStorageViewItemClass))
#define USAGE_IS_STORAGE_VIEW_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), USAGE_TYPE_STORAGE_VIEW_ITEM))
#define USAGE_IS_STORAGE_VIEW_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), USAGE_TYPE_STORAGE_VIEW_ITEM))
#define USAGE_STORAGE_VIEW_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), USAGE_TYPE_STORAGE_VIEW_ITEM, UsageStorageViewItemClass))

typedef struct _UsageStorageViewItem UsageStorageViewItem;
typedef struct _UsageStorageViewItemClass UsageStorageViewItemClass;
typedef struct _UsageStorageViewItemPrivate UsageStorageViewItemPrivate;
enum  {
	USAGE_STORAGE_VIEW_ITEM_0_PROPERTY,
	USAGE_STORAGE_VIEW_ITEM_PERCENTAGE_PROPERTY,
	USAGE_STORAGE_VIEW_ITEM_LOADED_PROPERTY,
	USAGE_STORAGE_VIEW_ITEM_COLOR_PROPERTY,
	USAGE_STORAGE_VIEW_ITEM_STYLE_CLASS_PROPERTY,
	USAGE_STORAGE_VIEW_ITEM_SHOW_CHECK_BUTTON_PROPERTY,
	USAGE_STORAGE_VIEW_ITEM_NUM_PROPERTIES
};
static GParamSpec* usage_storage_view_item_properties[USAGE_STORAGE_VIEW_ITEM_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _UsageStorageViewItem {
	GObject parent_instance;
	UsageStorageViewItemPrivate * priv;
	gchar* uri;
	gchar* name;
	guint64 size;
	GFileType type;
	GUserDirectory* dir;
	gchar* ontology;
	StorageViewType custom_type;
};

struct _UsageStorageViewItemClass {
	GObjectClass parent_class;
};

struct _UsageStorageViewItemPrivate {
	gdouble _percentage;
	gboolean _loaded;
	GdkRGBA _color;
	gchar* _style_class;
};

static gint UsageStorageViewItem_private_offset;
static gpointer usage_storage_view_item_parent_class = NULL;

GType storage_view_type_get_type (void) G_GNUC_CONST;
GType usage_storage_view_item_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (UsageStorageViewItem, g_object_unref)
UsageStorageViewItem* usage_storage_view_item_from_file (GFile* file);
UsageStorageViewItem* usage_storage_view_item_new (void);
UsageStorageViewItem* usage_storage_view_item_construct (GType object_type);
static void usage_storage_view_item_setup_tag_style (UsageStorageViewItem* self);
void usage_storage_view_item_set_style_class (UsageStorageViewItem* self,
                                              const gchar* value);
static gboolean _usage_storage_view_item_show_check_button (UsageStorageViewItem* self);
gdouble usage_storage_view_item_get_percentage (UsageStorageViewItem* self);
void usage_storage_view_item_set_percentage (UsageStorageViewItem* self,
                                             gdouble value);
gboolean usage_storage_view_item_get_loaded (UsageStorageViewItem* self);
void usage_storage_view_item_set_loaded (UsageStorageViewItem* self,
                                         gboolean value);
void usage_storage_view_item_get_color (UsageStorageViewItem* self,
                                        GdkRGBA * result);
void usage_storage_view_item_set_color (UsageStorageViewItem* self,
                                        GdkRGBA * value);
static gboolean _gdk_rgba_equal (const GdkRGBA * s1,
                          const GdkRGBA * s2);
const gchar* usage_storage_view_item_get_style_class (UsageStorageViewItem* self);
gboolean usage_storage_view_item_get_show_check_button (UsageStorageViewItem* self);
static void usage_storage_view_item_finalize (GObject * obj);
static void _vala_usage_storage_view_item_get_property (GObject * object,
                                                 guint property_id,
                                                 GValue * value,
                                                 GParamSpec * pspec);
static void _vala_usage_storage_view_item_set_property (GObject * object,
                                                 guint property_id,
                                                 const GValue * value,
                                                 GParamSpec * pspec);

GType
storage_view_type_get_type (void)
{
	static volatile gsize storage_view_type_type_id__volatile = 0;
	if (g_once_init_enter (&storage_view_type_type_id__volatile)) {
		static const GEnumValue values[] = {{STORAGE_VIEW_TYPE_NONE, "STORAGE_VIEW_TYPE_NONE", "none"}, {STORAGE_VIEW_TYPE_OS, "STORAGE_VIEW_TYPE_OS", "os"}, {STORAGE_VIEW_TYPE_UP_FOLDER, "STORAGE_VIEW_TYPE_UP_FOLDER", "up-folder"}, {STORAGE_VIEW_TYPE_AVAILABLE_GRAPH, "STORAGE_VIEW_TYPE_AVAILABLE_GRAPH", "available-graph"}, {STORAGE_VIEW_TYPE_ROOT_ITEM, "STORAGE_VIEW_TYPE_ROOT_ITEM", "root-item"}, {0, NULL, NULL}};
		GType storage_view_type_type_id;
		storage_view_type_type_id = g_enum_register_static ("StorageViewType", values);
		g_once_init_leave (&storage_view_type_type_id__volatile, storage_view_type_type_id);
	}
	return storage_view_type_type_id__volatile;
}

static inline gpointer
usage_storage_view_item_get_instance_private (UsageStorageViewItem* self)
{
	return G_STRUCT_MEMBER_P (self, UsageStorageViewItem_private_offset);
}

UsageStorageViewItem*
usage_storage_view_item_from_file (GFile* file)
{
	UsageStorageViewItem* result = NULL;
	UsageStorageViewItem* item = NULL;
	UsageStorageViewItem* _tmp0_;
	UsageStorageViewItem* _tmp1_;
	gchar* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 65 "../src/storage/storage-view-item.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 66 "../src/storage/storage-view-item.vala"
	_tmp0_ = usage_storage_view_item_new ();
#line 66 "../src/storage/storage-view-item.vala"
	item = _tmp0_;
#line 67 "../src/storage/storage-view-item.vala"
	_tmp1_ = item;
#line 67 "../src/storage/storage-view-item.vala"
	_tmp2_ = g_file_get_uri (file);
#line 67 "../src/storage/storage-view-item.vala"
	_g_free0 (_tmp1_->uri);
#line 67 "../src/storage/storage-view-item.vala"
	_tmp1_->uri = _tmp2_;
#line 171 "storage-view-item.c"
	{
		GFileInfo* info = NULL;
		GFileInfo* _tmp3_;
		UsageStorageViewItem* _tmp4_;
		GFileInfo* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		UsageStorageViewItem* _tmp8_;
		GFileInfo* _tmp9_;
		UsageStorageViewItem* _tmp10_;
		GFileInfo* _tmp11_;
#line 70 "../src/storage/storage-view-item.vala"
		_tmp3_ = g_file_query_info (file, G_FILE_ATTRIBUTE_STANDARD_SIZE "," G_FILE_ATTRIBUTE_STANDARD_NAME "," G_FILE_ATTRIBUTE_STANDARD_TYPE "," G_FILE_ATTRIBUTE_TRASH_ORIG_PATH, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error0_);
#line 70 "../src/storage/storage-view-item.vala"
		info = _tmp3_;
#line 70 "../src/storage/storage-view-item.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 189 "storage-view-item.c"
			goto __catch7_g_error;
		}
#line 72 "../src/storage/storage-view-item.vala"
		_tmp4_ = item;
#line 72 "../src/storage/storage-view-item.vala"
		_tmp5_ = info;
#line 72 "../src/storage/storage-view-item.vala"
		_tmp6_ = g_file_info_get_name (_tmp5_);
#line 72 "../src/storage/storage-view-item.vala"
		_tmp7_ = g_strdup (_tmp6_);
#line 72 "../src/storage/storage-view-item.vala"
		_g_free0 (_tmp4_->name);
#line 72 "../src/storage/storage-view-item.vala"
		_tmp4_->name = _tmp7_;
#line 73 "../src/storage/storage-view-item.vala"
		_tmp8_ = item;
#line 73 "../src/storage/storage-view-item.vala"
		_tmp9_ = info;
#line 73 "../src/storage/storage-view-item.vala"
		_tmp8_->size = (guint64) g_file_info_get_size (_tmp9_);
#line 74 "../src/storage/storage-view-item.vala"
		_tmp10_ = item;
#line 74 "../src/storage/storage-view-item.vala"
		_tmp11_ = info;
#line 74 "../src/storage/storage-view-item.vala"
		_tmp10_->type = g_file_info_get_file_type (_tmp11_);
#line 69 "../src/storage/storage-view-item.vala"
		_g_object_unref0 (info);
#line 218 "storage-view-item.c"
	}
	goto __finally7;
	__catch7_g_error:
	{
		GError* _error_ = NULL;
#line 69 "../src/storage/storage-view-item.vala"
		_error_ = _inner_error0_;
#line 69 "../src/storage/storage-view-item.vala"
		_inner_error0_ = NULL;
#line 76 "../src/storage/storage-view-item.vala"
		result = NULL;
#line 76 "../src/storage/storage-view-item.vala"
		_g_error_free0 (_error_);
#line 76 "../src/storage/storage-view-item.vala"
		_g_object_unref0 (item);
#line 76 "../src/storage/storage-view-item.vala"
		return result;
#line 236 "storage-view-item.c"
	}
	__finally7:
#line 69 "../src/storage/storage-view-item.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 69 "../src/storage/storage-view-item.vala"
		_g_object_unref0 (item);
#line 69 "../src/storage/storage-view-item.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 69 "../src/storage/storage-view-item.vala"
		g_clear_error (&_inner_error0_);
#line 69 "../src/storage/storage-view-item.vala"
		return NULL;
#line 249 "storage-view-item.c"
	}
#line 79 "../src/storage/storage-view-item.vala"
	result = item;
#line 79 "../src/storage/storage-view-item.vala"
	return result;
#line 255 "storage-view-item.c"
}

static void
usage_storage_view_item_setup_tag_style (UsageStorageViewItem* self)
{
	GFileType _tmp0_;
	GUserDirectory* _tmp1_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	GQuark _tmp6_ = 0U;
#line 107 "../src/storage/storage-view-item.vala"
	static GQuark _tmp5_label0 = 0;
#line 107 "../src/storage/storage-view-item.vala"
	static GQuark _tmp5_label1 = 0;
#line 107 "../src/storage/storage-view-item.vala"
	static GQuark _tmp5_label2 = 0;
#line 107 "../src/storage/storage-view-item.vala"
	static GQuark _tmp5_label3 = 0;
#line 107 "../src/storage/storage-view-item.vala"
	static GQuark _tmp5_label4 = 0;
#line 107 "../src/storage/storage-view-item.vala"
	static GQuark _tmp5_label5 = 0;
#line 107 "../src/storage/storage-view-item.vala"
	static GQuark _tmp5_label6 = 0;
#line 280 "storage-view-item.c"
	StorageViewType _tmp7_;
	const gchar* _tmp9_;
#line 82 "../src/storage/storage-view-item.vala"
	g_return_if_fail (self != NULL);
#line 83 "../src/storage/storage-view-item.vala"
	_tmp0_ = self->type;
#line 83 "../src/storage/storage-view-item.vala"
	if (_tmp0_ == G_FILE_TYPE_DIRECTORY) {
#line 84 "../src/storage/storage-view-item.vala"
		usage_storage_view_item_set_style_class (self, "folders");
#line 291 "storage-view-item.c"
	}
#line 87 "../src/storage/storage-view-item.vala"
	_tmp1_ = self->dir;
#line 87 "../src/storage/storage-view-item.vala"
	if (_tmp1_ != NULL) {
#line 297 "storage-view-item.c"
		GUserDirectory* _tmp2_;
#line 88 "../src/storage/storage-view-item.vala"
		_tmp2_ = self->dir;
#line 88 "../src/storage/storage-view-item.vala"
		switch (*_tmp2_) {
#line 88 "../src/storage/storage-view-item.vala"
			case G_USER_DIRECTORY_PICTURES:
#line 305 "storage-view-item.c"
			{
#line 90 "../src/storage/storage-view-item.vala"
				usage_storage_view_item_set_style_class (self, "pictures");
#line 91 "../src/storage/storage-view-item.vala"
				break;
#line 311 "storage-view-item.c"
			}
#line 88 "../src/storage/storage-view-item.vala"
			case G_USER_DIRECTORY_VIDEOS:
#line 315 "storage-view-item.c"
			{
#line 93 "../src/storage/storage-view-item.vala"
				usage_storage_view_item_set_style_class (self, "videos");
#line 94 "../src/storage/storage-view-item.vala"
				break;
#line 321 "storage-view-item.c"
			}
#line 88 "../src/storage/storage-view-item.vala"
			case G_USER_DIRECTORY_DOCUMENTS:
#line 325 "storage-view-item.c"
			{
#line 96 "../src/storage/storage-view-item.vala"
				usage_storage_view_item_set_style_class (self, "documents");
#line 97 "../src/storage/storage-view-item.vala"
				break;
#line 331 "storage-view-item.c"
			}
#line 88 "../src/storage/storage-view-item.vala"
			case G_USER_DIRECTORY_MUSIC:
#line 335 "storage-view-item.c"
			{
#line 99 "../src/storage/storage-view-item.vala"
				usage_storage_view_item_set_style_class (self, "music");
#line 100 "../src/storage/storage-view-item.vala"
				break;
#line 341 "storage-view-item.c"
			}
#line 88 "../src/storage/storage-view-item.vala"
			case G_USER_DIRECTORY_DOWNLOAD:
#line 345 "storage-view-item.c"
			{
#line 102 "../src/storage/storage-view-item.vala"
				usage_storage_view_item_set_style_class (self, "downloads");
#line 103 "../src/storage/storage-view-item.vala"
				break;
#line 351 "storage-view-item.c"
			}
			default:
#line 88 "../src/storage/storage-view-item.vala"
			break;
#line 356 "storage-view-item.c"
		}
	}
#line 107 "../src/storage/storage-view-item.vala"
	_tmp3_ = self->ontology;
#line 107 "../src/storage/storage-view-item.vala"
	_tmp4_ = _tmp3_;
#line 107 "../src/storage/storage-view-item.vala"
	_tmp6_ = (NULL == _tmp4_) ? 0 : g_quark_from_string (_tmp4_);
#line 107 "../src/storage/storage-view-item.vala"
	if (_tmp6_ == ((0 != _tmp5_label0) ? _tmp5_label0 : (_tmp5_label0 = g_quark_from_static_string ("nmm#MusicPiece")))) {
#line 107 "../src/storage/storage-view-item.vala"
		switch (0) {
#line 369 "storage-view-item.c"
			default:
			{
#line 109 "../src/storage/storage-view-item.vala"
				usage_storage_view_item_set_style_class (self, "music");
#line 110 "../src/storage/storage-view-item.vala"
				break;
#line 376 "storage-view-item.c"
			}
		}
	} else if (_tmp6_ == ((0 != _tmp5_label1) ? _tmp5_label1 : (_tmp5_label1 = g_quark_from_static_string ("nmm#Photo")))) {
#line 107 "../src/storage/storage-view-item.vala"
		switch (0) {
#line 382 "storage-view-item.c"
			default:
			{
#line 112 "../src/storage/storage-view-item.vala"
				usage_storage_view_item_set_style_class (self, "pictures");
#line 113 "../src/storage/storage-view-item.vala"
				break;
#line 389 "storage-view-item.c"
			}
		}
	} else if (_tmp6_ == ((0 != _tmp5_label2) ? _tmp5_label2 : (_tmp5_label2 = g_quark_from_static_string ("nmm#Video")))) {
#line 107 "../src/storage/storage-view-item.vala"
		switch (0) {
#line 395 "storage-view-item.c"
			default:
			{
#line 115 "../src/storage/storage-view-item.vala"
				usage_storage_view_item_set_style_class (self, "videos");
#line 116 "../src/storage/storage-view-item.vala"
				break;
#line 402 "storage-view-item.c"
			}
		}
	} else if ((((_tmp6_ == ((0 != _tmp5_label3) ? _tmp5_label3 : (_tmp5_label3 = g_quark_from_static_string ("nfo#PaginatedTextDocument")))) || (_tmp6_ == ((0 != _tmp5_label4) ? _tmp5_label4 : (_tmp5_label4 = g_quark_from_static_string ("nfo#PlainTextDocument"))))) || (_tmp6_ == ((0 != _tmp5_label5) ? _tmp5_label5 : (_tmp5_label5 = g_quark_from_static_string ("nfo#FileDataObject"))))) || (_tmp6_ == ((0 != _tmp5_label6) ? _tmp5_label6 : (_tmp5_label6 = g_quark_from_static_string ("nfo#EBook"))))) {
#line 107 "../src/storage/storage-view-item.vala"
		switch (0) {
#line 408 "storage-view-item.c"
			default:
			{
#line 121 "../src/storage/storage-view-item.vala"
				usage_storage_view_item_set_style_class (self, "documents");
#line 122 "../src/storage/storage-view-item.vala"
				break;
#line 415 "storage-view-item.c"
			}
		}
	}
#line 125 "../src/storage/storage-view-item.vala"
	_tmp7_ = self->custom_type;
#line 125 "../src/storage/storage-view-item.vala"
	if (_tmp7_ != STORAGE_VIEW_TYPE_NONE) {
#line 423 "storage-view-item.c"
		StorageViewType _tmp8_;
#line 126 "../src/storage/storage-view-item.vala"
		_tmp8_ = self->custom_type;
#line 126 "../src/storage/storage-view-item.vala"
		switch (_tmp8_) {
#line 126 "../src/storage/storage-view-item.vala"
			case STORAGE_VIEW_TYPE_OS:
#line 431 "storage-view-item.c"
			{
#line 128 "../src/storage/storage-view-item.vala"
				usage_storage_view_item_set_style_class (self, "os-tag");
#line 129 "../src/storage/storage-view-item.vala"
				break;
#line 437 "storage-view-item.c"
			}
#line 126 "../src/storage/storage-view-item.vala"
			case STORAGE_VIEW_TYPE_AVAILABLE_GRAPH:
#line 441 "storage-view-item.c"
			{
#line 131 "../src/storage/storage-view-item.vala"
				usage_storage_view_item_set_style_class (self, "available-tag");
#line 132 "../src/storage/storage-view-item.vala"
				break;
#line 447 "storage-view-item.c"
			}
			default:
#line 126 "../src/storage/storage-view-item.vala"
			break;
#line 452 "storage-view-item.c"
		}
	}
#line 136 "../src/storage/storage-view-item.vala"
	_tmp9_ = self->priv->_style_class;
#line 136 "../src/storage/storage-view-item.vala"
	if (_tmp9_ == NULL) {
#line 137 "../src/storage/storage-view-item.vala"
		usage_storage_view_item_set_style_class (self, "files");
#line 461 "storage-view-item.c"
	}
}

static gboolean
_usage_storage_view_item_show_check_button (UsageStorageViewItem* self)
{
	gboolean result = FALSE;
	StorageViewType _tmp0_;
	GUserDirectory* _tmp2_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	GQuark _tmp7_ = 0U;
#line 161 "../src/storage/storage-view-item.vala"
	static GQuark _tmp6_label0 = 0;
#line 161 "../src/storage/storage-view-item.vala"
	static GQuark _tmp6_label1 = 0;
#line 161 "../src/storage/storage-view-item.vala"
	static GQuark _tmp6_label2 = 0;
#line 161 "../src/storage/storage-view-item.vala"
	static GQuark _tmp6_label3 = 0;
#line 161 "../src/storage/storage-view-item.vala"
	static GQuark _tmp6_label4 = 0;
#line 161 "../src/storage/storage-view-item.vala"
	static GQuark _tmp6_label5 = 0;
#line 161 "../src/storage/storage-view-item.vala"
	static GQuark _tmp6_label6 = 0;
#line 140 "../src/storage/storage-view-item.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 141 "../src/storage/storage-view-item.vala"
	_tmp0_ = self->custom_type;
#line 141 "../src/storage/storage-view-item.vala"
	if (_tmp0_ != STORAGE_VIEW_TYPE_NONE) {
#line 494 "storage-view-item.c"
		StorageViewType _tmp1_;
#line 142 "../src/storage/storage-view-item.vala"
		_tmp1_ = self->custom_type;
#line 142 "../src/storage/storage-view-item.vala"
		switch (_tmp1_) {
#line 142 "../src/storage/storage-view-item.vala"
			case STORAGE_VIEW_TYPE_OS:
#line 142 "../src/storage/storage-view-item.vala"
			case STORAGE_VIEW_TYPE_AVAILABLE_GRAPH:
#line 142 "../src/storage/storage-view-item.vala"
			case STORAGE_VIEW_TYPE_UP_FOLDER:
#line 506 "storage-view-item.c"
			{
#line 146 "../src/storage/storage-view-item.vala"
				result = FALSE;
#line 146 "../src/storage/storage-view-item.vala"
				return result;
#line 512 "storage-view-item.c"
			}
			default:
#line 142 "../src/storage/storage-view-item.vala"
			break;
#line 517 "storage-view-item.c"
		}
	}
#line 150 "../src/storage/storage-view-item.vala"
	_tmp2_ = self->dir;
#line 150 "../src/storage/storage-view-item.vala"
	if (_tmp2_ != NULL) {
#line 524 "storage-view-item.c"
		GUserDirectory* _tmp3_;
#line 151 "../src/storage/storage-view-item.vala"
		_tmp3_ = self->dir;
#line 151 "../src/storage/storage-view-item.vala"
		switch (*_tmp3_) {
#line 151 "../src/storage/storage-view-item.vala"
			case G_USER_DIRECTORY_PICTURES:
#line 151 "../src/storage/storage-view-item.vala"
			case G_USER_DIRECTORY_VIDEOS:
#line 151 "../src/storage/storage-view-item.vala"
			case G_USER_DIRECTORY_DOCUMENTS:
#line 151 "../src/storage/storage-view-item.vala"
			case G_USER_DIRECTORY_MUSIC:
#line 151 "../src/storage/storage-view-item.vala"
			case G_USER_DIRECTORY_DOWNLOAD:
#line 540 "storage-view-item.c"
			{
#line 157 "../src/storage/storage-view-item.vala"
				result = TRUE;
#line 157 "../src/storage/storage-view-item.vala"
				return result;
#line 546 "storage-view-item.c"
			}
			default:
#line 151 "../src/storage/storage-view-item.vala"
			break;
#line 551 "storage-view-item.c"
		}
	}
#line 161 "../src/storage/storage-view-item.vala"
	_tmp4_ = self->ontology;
#line 161 "../src/storage/storage-view-item.vala"
	_tmp5_ = _tmp4_;
#line 161 "../src/storage/storage-view-item.vala"
	_tmp7_ = (NULL == _tmp5_) ? 0 : g_quark_from_string (_tmp5_);
#line 161 "../src/storage/storage-view-item.vala"
	if (((((((_tmp7_ == ((0 != _tmp6_label0) ? _tmp6_label0 : (_tmp6_label0 = g_quark_from_static_string ("nmm#MusicPiece")))) || (_tmp7_ == ((0 != _tmp6_label1) ? _tmp6_label1 : (_tmp6_label1 = g_quark_from_static_string ("nmm#Photo"))))) || (_tmp7_ == ((0 != _tmp6_label2) ? _tmp6_label2 : (_tmp6_label2 = g_quark_from_static_string ("nmm#Video"))))) || (_tmp7_ == ((0 != _tmp6_label3) ? _tmp6_label3 : (_tmp6_label3 = g_quark_from_static_string ("nfo#PaginatedTextDocument"))))) || (_tmp7_ == ((0 != _tmp6_label4) ? _tmp6_label4 : (_tmp6_label4 = g_quark_from_static_string ("nfo#PlainTextDocument"))))) || (_tmp7_ == ((0 != _tmp6_label5) ? _tmp6_label5 : (_tmp6_label5 = g_quark_from_static_string ("nfo#FileDataObject"))))) || (_tmp7_ == ((0 != _tmp6_label6) ? _tmp6_label6 : (_tmp6_label6 = g_quark_from_static_string ("nfo#EBook"))))) {
#line 161 "../src/storage/storage-view-item.vala"
		switch (0) {
#line 564 "storage-view-item.c"
			default:
			{
#line 169 "../src/storage/storage-view-item.vala"
				result = TRUE;
#line 169 "../src/storage/storage-view-item.vala"
				return result;
#line 571 "storage-view-item.c"
			}
		}
	}
#line 172 "../src/storage/storage-view-item.vala"
	result = FALSE;
#line 172 "../src/storage/storage-view-item.vala"
	return result;
#line 579 "storage-view-item.c"
}

UsageStorageViewItem*
usage_storage_view_item_construct (GType object_type)
{
	UsageStorageViewItem * self = NULL;
#line 30 "../src/storage/storage-view-item.vala"
	self = (UsageStorageViewItem*) g_object_new (object_type, NULL);
#line 30 "../src/storage/storage-view-item.vala"
	return self;
#line 590 "storage-view-item.c"
}

UsageStorageViewItem*
usage_storage_view_item_new (void)
{
#line 30 "../src/storage/storage-view-item.vala"
	return usage_storage_view_item_construct (USAGE_TYPE_STORAGE_VIEW_ITEM);
#line 598 "storage-view-item.c"
}

gdouble
usage_storage_view_item_get_percentage (UsageStorageViewItem* self)
{
	gdouble result;
#line 31 "../src/storage/storage-view-item.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 31 "../src/storage/storage-view-item.vala"
	result = self->priv->_percentage;
#line 31 "../src/storage/storage-view-item.vala"
	return result;
#line 611 "storage-view-item.c"
}

void
usage_storage_view_item_set_percentage (UsageStorageViewItem* self,
                                        gdouble value)
{
#line 31 "../src/storage/storage-view-item.vala"
	g_return_if_fail (self != NULL);
#line 31 "../src/storage/storage-view-item.vala"
	if (usage_storage_view_item_get_percentage (self) != value) {
#line 31 "../src/storage/storage-view-item.vala"
		self->priv->_percentage = value;
#line 31 "../src/storage/storage-view-item.vala"
		g_object_notify_by_pspec ((GObject *) self, usage_storage_view_item_properties[USAGE_STORAGE_VIEW_ITEM_PERCENTAGE_PROPERTY]);
#line 626 "storage-view-item.c"
	}
}

gboolean
usage_storage_view_item_get_loaded (UsageStorageViewItem* self)
{
	gboolean result;
#line 32 "../src/storage/storage-view-item.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 32 "../src/storage/storage-view-item.vala"
	result = self->priv->_loaded;
#line 32 "../src/storage/storage-view-item.vala"
	return result;
#line 640 "storage-view-item.c"
}

void
usage_storage_view_item_set_loaded (UsageStorageViewItem* self,
                                    gboolean value)
{
#line 32 "../src/storage/storage-view-item.vala"
	g_return_if_fail (self != NULL);
#line 32 "../src/storage/storage-view-item.vala"
	if (usage_storage_view_item_get_loaded (self) != value) {
#line 32 "../src/storage/storage-view-item.vala"
		self->priv->_loaded = value;
#line 32 "../src/storage/storage-view-item.vala"
		g_object_notify_by_pspec ((GObject *) self, usage_storage_view_item_properties[USAGE_STORAGE_VIEW_ITEM_LOADED_PROPERTY]);
#line 655 "storage-view-item.c"
	}
}

void
usage_storage_view_item_get_color (UsageStorageViewItem* self,
                                   GdkRGBA * result)
{
	GdkRGBA _tmp0_;
#line 33 "../src/storage/storage-view-item.vala"
	g_return_if_fail (self != NULL);
#line 33 "../src/storage/storage-view-item.vala"
	_tmp0_ = self->priv->_color;
#line 33 "../src/storage/storage-view-item.vala"
	*result = _tmp0_;
#line 33 "../src/storage/storage-view-item.vala"
	return;
#line 672 "storage-view-item.c"
}

static gboolean
_gdk_rgba_equal (const GdkRGBA * s1,
                 const GdkRGBA * s2)
{
#line 33 "../src/storage/storage-view-item.vala"
	if (s1 == s2) {
#line 33 "../src/storage/storage-view-item.vala"
		return TRUE;
#line 683 "storage-view-item.c"
	}
#line 33 "../src/storage/storage-view-item.vala"
	if (s1 == NULL) {
#line 33 "../src/storage/storage-view-item.vala"
		return FALSE;
#line 689 "storage-view-item.c"
	}
#line 33 "../src/storage/storage-view-item.vala"
	if (s2 == NULL) {
#line 33 "../src/storage/storage-view-item.vala"
		return FALSE;
#line 695 "storage-view-item.c"
	}
#line 33 "../src/storage/storage-view-item.vala"
	if (s1->red != s2->red) {
#line 33 "../src/storage/storage-view-item.vala"
		return FALSE;
#line 701 "storage-view-item.c"
	}
#line 33 "../src/storage/storage-view-item.vala"
	if (s1->green != s2->green) {
#line 33 "../src/storage/storage-view-item.vala"
		return FALSE;
#line 707 "storage-view-item.c"
	}
#line 33 "../src/storage/storage-view-item.vala"
	if (s1->blue != s2->blue) {
#line 33 "../src/storage/storage-view-item.vala"
		return FALSE;
#line 713 "storage-view-item.c"
	}
#line 33 "../src/storage/storage-view-item.vala"
	if (s1->alpha != s2->alpha) {
#line 33 "../src/storage/storage-view-item.vala"
		return FALSE;
#line 719 "storage-view-item.c"
	}
#line 33 "../src/storage/storage-view-item.vala"
	return TRUE;
#line 723 "storage-view-item.c"
}

void
usage_storage_view_item_set_color (UsageStorageViewItem* self,
                                   GdkRGBA * value)
{
	GdkRGBA old_value;
#line 33 "../src/storage/storage-view-item.vala"
	g_return_if_fail (self != NULL);
#line 33 "../src/storage/storage-view-item.vala"
	usage_storage_view_item_get_color (self, &old_value);
#line 33 "../src/storage/storage-view-item.vala"
	if (_gdk_rgba_equal (value, &old_value) != TRUE) {
#line 737 "storage-view-item.c"
		GdkRGBA _tmp0_;
#line 33 "../src/storage/storage-view-item.vala"
		_tmp0_ = *value;
#line 33 "../src/storage/storage-view-item.vala"
		self->priv->_color = _tmp0_;
#line 33 "../src/storage/storage-view-item.vala"
		g_object_notify_by_pspec ((GObject *) self, usage_storage_view_item_properties[USAGE_STORAGE_VIEW_ITEM_COLOR_PROPERTY]);
#line 745 "storage-view-item.c"
	}
}

const gchar*
usage_storage_view_item_get_style_class (UsageStorageViewItem* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	const gchar* _tmp2_;
#line 49 "../src/storage/storage-view-item.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 50 "../src/storage/storage-view-item.vala"
	_tmp0_ = self->priv->_style_class;
#line 50 "../src/storage/storage-view-item.vala"
	if (_tmp0_ != NULL) {
#line 761 "storage-view-item.c"
		const gchar* _tmp1_;
#line 51 "../src/storage/storage-view-item.vala"
		_tmp1_ = self->priv->_style_class;
#line 51 "../src/storage/storage-view-item.vala"
		result = _tmp1_;
#line 51 "../src/storage/storage-view-item.vala"
		return result;
#line 769 "storage-view-item.c"
	}
#line 53 "../src/storage/storage-view-item.vala"
	usage_storage_view_item_setup_tag_style (self);
#line 55 "../src/storage/storage-view-item.vala"
	_tmp2_ = self->priv->_style_class;
#line 55 "../src/storage/storage-view-item.vala"
	result = _tmp2_;
#line 55 "../src/storage/storage-view-item.vala"
	return result;
#line 779 "storage-view-item.c"
}

void
usage_storage_view_item_set_style_class (UsageStorageViewItem* self,
                                         const gchar* value)
{
	gchar* _tmp0_;
#line 46 "../src/storage/storage-view-item.vala"
	g_return_if_fail (self != NULL);
#line 47 "../src/storage/storage-view-item.vala"
	_tmp0_ = g_strdup (value);
#line 47 "../src/storage/storage-view-item.vala"
	_g_free0 (self->priv->_style_class);
#line 47 "../src/storage/storage-view-item.vala"
	self->priv->_style_class = _tmp0_;
#line 46 "../src/storage/storage-view-item.vala"
	g_object_notify_by_pspec ((GObject *) self, usage_storage_view_item_properties[USAGE_STORAGE_VIEW_ITEM_STYLE_CLASS_PROPERTY]);
#line 797 "storage-view-item.c"
}

gboolean
usage_storage_view_item_get_show_check_button (UsageStorageViewItem* self)
{
	gboolean result;
#line 60 "../src/storage/storage-view-item.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 61 "../src/storage/storage-view-item.vala"
	result = _usage_storage_view_item_show_check_button (self);
#line 61 "../src/storage/storage-view-item.vala"
	return result;
#line 810 "storage-view-item.c"
}

static void
usage_storage_view_item_class_init (UsageStorageViewItemClass * klass,
                                    gpointer klass_data)
{
#line 30 "../src/storage/storage-view-item.vala"
	usage_storage_view_item_parent_class = g_type_class_peek_parent (klass);
#line 30 "../src/storage/storage-view-item.vala"
	g_type_class_adjust_private_offset (klass, &UsageStorageViewItem_private_offset);
#line 30 "../src/storage/storage-view-item.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_usage_storage_view_item_get_property;
#line 30 "../src/storage/storage-view-item.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_usage_storage_view_item_set_property;
#line 30 "../src/storage/storage-view-item.vala"
	G_OBJECT_CLASS (klass)->finalize = usage_storage_view_item_finalize;
#line 30 "../src/storage/storage-view-item.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), USAGE_STORAGE_VIEW_ITEM_PERCENTAGE_PROPERTY, usage_storage_view_item_properties[USAGE_STORAGE_VIEW_ITEM_PERCENTAGE_PROPERTY] = g_param_spec_double ("percentage", "percentage", "percentage", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../src/storage/storage-view-item.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), USAGE_STORAGE_VIEW_ITEM_LOADED_PROPERTY, usage_storage_view_item_properties[USAGE_STORAGE_VIEW_ITEM_LOADED_PROPERTY] = g_param_spec_boolean ("loaded", "loaded", "loaded", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../src/storage/storage-view-item.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), USAGE_STORAGE_VIEW_ITEM_COLOR_PROPERTY, usage_storage_view_item_properties[USAGE_STORAGE_VIEW_ITEM_COLOR_PROPERTY] = g_param_spec_boxed ("color", "color", "color", gdk_rgba_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../src/storage/storage-view-item.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), USAGE_STORAGE_VIEW_ITEM_STYLE_CLASS_PROPERTY, usage_storage_view_item_properties[USAGE_STORAGE_VIEW_ITEM_STYLE_CLASS_PROPERTY] = g_param_spec_string ("style-class", "style-class", "style-class", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 30 "../src/storage/storage-view-item.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), USAGE_STORAGE_VIEW_ITEM_SHOW_CHECK_BUTTON_PROPERTY, usage_storage_view_item_properties[USAGE_STORAGE_VIEW_ITEM_SHOW_CHECK_BUTTON_PROPERTY] = g_param_spec_boolean ("show-check-button", "show-check-button", "show-check-button", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 837 "storage-view-item.c"
}

static void
usage_storage_view_item_instance_init (UsageStorageViewItem * self,
                                       gpointer klass)
{
#line 30 "../src/storage/storage-view-item.vala"
	self->priv = usage_storage_view_item_get_instance_private (self);
#line 32 "../src/storage/storage-view-item.vala"
	self->priv->_loaded = FALSE;
#line 42 "../src/storage/storage-view-item.vala"
	self->custom_type = STORAGE_VIEW_TYPE_NONE;
#line 44 "../src/storage/storage-view-item.vala"
	self->priv->_style_class = NULL;
#line 852 "storage-view-item.c"
}

static void
usage_storage_view_item_finalize (GObject * obj)
{
	UsageStorageViewItem * self;
#line 30 "../src/storage/storage-view-item.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, USAGE_TYPE_STORAGE_VIEW_ITEM, UsageStorageViewItem);
#line 35 "../src/storage/storage-view-item.vala"
	_g_free0 (self->uri);
#line 36 "../src/storage/storage-view-item.vala"
	_g_free0 (self->name);
#line 40 "../src/storage/storage-view-item.vala"
	_g_free0 (self->dir);
#line 41 "../src/storage/storage-view-item.vala"
	_g_free0 (self->ontology);
#line 44 "../src/storage/storage-view-item.vala"
	_g_free0 (self->priv->_style_class);
#line 30 "../src/storage/storage-view-item.vala"
	G_OBJECT_CLASS (usage_storage_view_item_parent_class)->finalize (obj);
#line 873 "storage-view-item.c"
}

GType
usage_storage_view_item_get_type (void)
{
	static volatile gsize usage_storage_view_item_type_id__volatile = 0;
	if (g_once_init_enter (&usage_storage_view_item_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (UsageStorageViewItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) usage_storage_view_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UsageStorageViewItem), 0, (GInstanceInitFunc) usage_storage_view_item_instance_init, NULL };
		GType usage_storage_view_item_type_id;
		usage_storage_view_item_type_id = g_type_register_static (G_TYPE_OBJECT, "UsageStorageViewItem", &g_define_type_info, 0);
		UsageStorageViewItem_private_offset = g_type_add_instance_private (usage_storage_view_item_type_id, sizeof (UsageStorageViewItemPrivate));
		g_once_init_leave (&usage_storage_view_item_type_id__volatile, usage_storage_view_item_type_id);
	}
	return usage_storage_view_item_type_id__volatile;
}

static void
_vala_usage_storage_view_item_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec)
{
	UsageStorageViewItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, USAGE_TYPE_STORAGE_VIEW_ITEM, UsageStorageViewItem);
#line 30 "../src/storage/storage-view-item.vala"
	switch (property_id) {
#line 30 "../src/storage/storage-view-item.vala"
		case USAGE_STORAGE_VIEW_ITEM_PERCENTAGE_PROPERTY:
#line 30 "../src/storage/storage-view-item.vala"
		g_value_set_double (value, usage_storage_view_item_get_percentage (self));
#line 30 "../src/storage/storage-view-item.vala"
		break;
#line 30 "../src/storage/storage-view-item.vala"
		case USAGE_STORAGE_VIEW_ITEM_LOADED_PROPERTY:
#line 30 "../src/storage/storage-view-item.vala"
		g_value_set_boolean (value, usage_storage_view_item_get_loaded (self));
#line 30 "../src/storage/storage-view-item.vala"
		break;
#line 30 "../src/storage/storage-view-item.vala"
		case USAGE_STORAGE_VIEW_ITEM_COLOR_PROPERTY:
#line 914 "storage-view-item.c"
		{
			GdkRGBA boxed;
#line 30 "../src/storage/storage-view-item.vala"
			usage_storage_view_item_get_color (self, &boxed);
#line 30 "../src/storage/storage-view-item.vala"
			g_value_set_boxed (value, &boxed);
#line 921 "storage-view-item.c"
		}
#line 30 "../src/storage/storage-view-item.vala"
		break;
#line 30 "../src/storage/storage-view-item.vala"
		case USAGE_STORAGE_VIEW_ITEM_STYLE_CLASS_PROPERTY:
#line 30 "../src/storage/storage-view-item.vala"
		g_value_set_string (value, usage_storage_view_item_get_style_class (self));
#line 30 "../src/storage/storage-view-item.vala"
		break;
#line 30 "../src/storage/storage-view-item.vala"
		case USAGE_STORAGE_VIEW_ITEM_SHOW_CHECK_BUTTON_PROPERTY:
#line 30 "../src/storage/storage-view-item.vala"
		g_value_set_boolean (value, usage_storage_view_item_get_show_check_button (self));
#line 30 "../src/storage/storage-view-item.vala"
		break;
#line 937 "storage-view-item.c"
		default:
#line 30 "../src/storage/storage-view-item.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 30 "../src/storage/storage-view-item.vala"
		break;
#line 943 "storage-view-item.c"
	}
}

static void
_vala_usage_storage_view_item_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec)
{
	UsageStorageViewItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, USAGE_TYPE_STORAGE_VIEW_ITEM, UsageStorageViewItem);
#line 30 "../src/storage/storage-view-item.vala"
	switch (property_id) {
#line 30 "../src/storage/storage-view-item.vala"
		case USAGE_STORAGE_VIEW_ITEM_PERCENTAGE_PROPERTY:
#line 30 "../src/storage/storage-view-item.vala"
		usage_storage_view_item_set_percentage (self, g_value_get_double (value));
#line 30 "../src/storage/storage-view-item.vala"
		break;
#line 30 "../src/storage/storage-view-item.vala"
		case USAGE_STORAGE_VIEW_ITEM_LOADED_PROPERTY:
#line 30 "../src/storage/storage-view-item.vala"
		usage_storage_view_item_set_loaded (self, g_value_get_boolean (value));
#line 30 "../src/storage/storage-view-item.vala"
		break;
#line 30 "../src/storage/storage-view-item.vala"
		case USAGE_STORAGE_VIEW_ITEM_COLOR_PROPERTY:
#line 30 "../src/storage/storage-view-item.vala"
		usage_storage_view_item_set_color (self, g_value_get_boxed (value));
#line 30 "../src/storage/storage-view-item.vala"
		break;
#line 30 "../src/storage/storage-view-item.vala"
		case USAGE_STORAGE_VIEW_ITEM_STYLE_CLASS_PROPERTY:
#line 30 "../src/storage/storage-view-item.vala"
		usage_storage_view_item_set_style_class (self, g_value_get_string (value));
#line 30 "../src/storage/storage-view-item.vala"
		break;
#line 981 "storage-view-item.c"
		default:
#line 30 "../src/storage/storage-view-item.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 30 "../src/storage/storage-view-item.vala"
		break;
#line 987 "storage-view-item.c"
	}
}

